#######################################################################
#
# BUILTINS.MAK
#
# NOTE: THIS MAKEFILE REQUIRES A UTILTY CALLED MAKEEXEC.EXE TO BE IN
#       YOUR SEARCH PATH.
#
#######################################################################

LANGUAGE=4

EURO_TEST=99
WIDE_ROMAN_TEST=100

MDB_DIR=..\s_mesg
MESSAGE_DIR=..\s_mesg
EUROPE_DIR=$(MESSAGE_DIR)\euro
WIDEJP_DIR=$(MESSAGE_DIR)\widejp
WORD_COUNT_DIR=$(MESSAGE_DIR)\wordcnt

TRANSLATION_REVISION=1.0
VERSION=$(MAJOR_VERSION),$(MINOR_VERSION),$(REVISION)
MDB_VERS=$(MAJOR_VERSION).$(MINOR_VERSION).$(REVISION)


#-----------------------------------------------------------------------------
#	This section will diminish the amount of stuff echoed to the screen
#	and allow for continuing compilation even if another file has an error
#   ( only for PROVO_ADG right now )
#-----------------------------------------------------------------------------
!IFDEF PROVO_ADG
#
#  If Verbose is set we will echo the SET and other commands
#
!IFNDEF VERBOSE
!IF "$(OS)" == "Windows_NT"
SILENT		=@
!ELSE
SILENT		=
!ENDIF
SILENT_SETFLAGS	=$(SILENT)
SILENT_SET	=$(SILENT)
SILENT_CMD	=$(SILENT)
!ENDIF   # VERBOSE

!IFNDEF STOP_ON_ERROR
CONTINUE	=-
!ENDIF   # STOP_ON_ERROR

!ELSE    # NOT PROVO_ADG
!IF "$(OS)" == "Windows_NT"
SILENT_SETFLAGS	=@
!ELSE
SILENT_SETFLAGS	=
!ENDIF
SILENT_SET	=
SILENT_CMD	=
!ENDIF   # PROVO_ADG

# Server name for mapping and locating tools.
# ----

# following portion would be modified later to reflect the proper tools server
# and map commands

!IFNDEF PRIVATE_TOOLS_DIR	# PRIVATE_TOOLS_DIR !defined -> normal
# Here we define TOOLS_DRV and MAP_TOOLS_CMD.
# (MAP_COMMAND, DEFAULT_TOOLS_SERVER and TOOLS_DB are used internally).
TOOLS_DRV	=o:
!IFNDEF PROVO_ADG		# Build in San Jose
MAP_COMMAND	=\\sjf-release2\sys\public\map
DEFAULT_TOOLS_SERVER	=sjf-release2/tools:
!IFDEF TOOLS_SERVER
TOOLS_DB	=$(TOOLS_SERVER)
!ELSE	# TOOLS_SERVER is not defined
TOOLS_DB	=$(DEFAULT_TOOLS_SERVER)
!ENDIF	# TOOLS_SERVER
!ELSE    # PROVO_ADG is defined -- Build in Provo
!IFDEF USER
!MESSAGE Using Provo's Tools . . . (for $(USER))
!ELSE	# USER is not defined
!MESSAGE Using Provo's Tools
!ENDIF	# USER
MAP_COMMAND	=\\prv-dev11\sys\public\map
DEFAULT_TOOLS_SERVER	=prv-dev11/adg:
!IFDEF TOOLS_SERVER
TOOLS_DB	=$(TOOLS_SERVER)\Tools
!ELSE	# TOOLS_SERVER is not defined
TOOLS_DB=$(DEFAULT_TOOLS_SERVER)\Tools
!ENDIF   # TOOLS_SERVER
!ENDIF   # PROVO_ADG
MAP_TOOLS_CMD	=$(SILENT)makeexec $(MAP_COMMAND) root $(TOOLS_DRV)=$(TOOLS_DB)
!ELSE	# PRIVATE_TOOLS_DIR is defined
TOOLS_DRV	=$(PRIVATE_TOOLS_DIR)
MAP_TOOLS_CMD	=
!ENDIF	# PRIVATE_TOOLS_DIR

!IF EXIST ($(TOOLS_DRV)\misc\makeexec.exe)
DRV_MAPPED	=1
!ENDIF

# default root directory of this build
# ----
ROOT		= C:\Novell\ndk\nwsdk

# NWSDK and NWOS file location
# ----
NWSDK_INC_DIR		=$(ROOT)\import\nwsdk.inc
NWOS_INC_DIR		=$(ROOT)\import\nwos.inc
NSAPI_INC_DIR		=$(ROOT)\import\nsapi.inc
NWSDK_IMP_DIR		=$(ROOT)\import\nwsdk.imp
NWOS_IMP_DIR		=$(ROOT)\import\nwos.imp
IMPORTS			=$(NWSDK_IMP_DIR)

NDK			=$(ROOT)\ndk
NDK_PKI			=$(NDK)\_auth_PKI_export\include
NDK_COREOS		=$(NDK)\_coreos_exp\inc
NDK_LIBC		=$(NDK)\libc\include
NDK_ARPA		=$(NDK_LIBC)\arpa
NDK_NETINET		=$(NDK_LIBC)\netinet
NDK_NKS			=$(NDK_LIBC)\nks
NDK_SYS			=$(NDK_LIBC)\sys
NDK_WINSOCK		=$(NDK_LIBC)\winsock
NDK_NDS_DCLIENT		=$(NDK)\nds_dclient_export\include
NDK_NDS_NW		=$(NDK_NDS_DCLIENT)\nw
NDK_NDS_PUBLIC		=$(NDK_NDS_DCLIENT)\public
NDK_NMAS		=$(NDK)\NMAS_NDK\nwsdk\include
NDK_INCLUDE_PATH	=$(NDK_PKI);$(NDK_COREOS);$(NDK_LIBC);$(NDK_ARPA);$(NDK_NETINET);$(NDK_NKS);$(NDK_SYS);$(NDK_WINSOCK);$(NDK_NDS_DCLIENT);$(NDK_NW);$(NDK_NDS_PUBLIC);$(NDK_NMAS)

# set up the paths to inc and imp files. Append them to XINC for now.
# ----
LOCAL_IMP	=$(ROOT)\imports
LOCAL_INC	=$(ROOT)\h_appli

INCLUDE_PATH	=$(NWSDK_INC_DIR);$(NWOS_INC_DIR);$(NSAPI_INC_DIR);$(LOCAL_INC);$(ROOT)

INC_SEMI	=$(XINC_SEMI)
INC_COMMA	=$(XINC_COMMA)

# -dw (ignore warning) 22 (catch block empty) -w2 (warning level 2: max, 0: min) -wx (treat warning as error)
############### SETUP Compilers and Flags #############################
JAVAC_FLAGS	= -deprecation -classpath $(CLASSPATH)
!IFDEF PRODUCTION
DEBUG		=
OPTIMIZE	=1
!ENDIF
!IFDEF DEBUG
# -g (generate all debug info) -noinline (turn off function inlining)
JAVAC_FLAGS	=$(JAVAC_FLAGS) -g
JAVA_OUTPUT	=debug
!ELSE
# -g:none (generate no debug info) -compact (minimize class file size)
#JAVAC_FLAGS	=$(JAVAC_FLAGS) -g:none
JAVAC_FLAGS	=$(JAVAC_FLAGS)
JAVA_OUTPUT	=release
!ENDIF
!IFDEF OPTIMIZE
# -XO (optimizations except cross class inlining) -Xinterclass (inline across classes) (use only 1 of these flags)
JAVAC_FLAGS	=$(JAVAC_FLAGS) -O
!ENDIF
!IFDEF PROFILE
JAVAC_FLAGS	=$(JAVAC_FLAGS) -profile
!ENDIF
!IFDEF DEPEND
JAVAC_FLAGS	=$(JAVAC_FLAGS) -depend $*.dep
!ENDIF
!IFDEF VERBOSE
JAVAC_FLAGS	=$(JAVAC_FLAGS) -verbose
!ENDIF
!IFDEF JAVA_OUTPUT_DIR
JAVAC_FLAGS	=$(JAVAC_FLAGS) -d $(JAVA_OUTPUT_DIR)\$(JAVA_OUTPUT)
!ENDIF
JAVAH_FLAGS	= -jni
JAVA2IIOP_FLAGS	=-no_examples -no_comments -no_tie

!IFDEF CLASSPATH
OCLASSPATH	=$(CLASSPATH)
!ENDIF

############### San Jose ##############################################

!IFNDEF PROVO_ADG
JDK_116				=$(TOOLS_DRV)\jdk\V1.1.6
JDK					=$(JDK_116)
JDK_BIN				=$(JDK)\bin
#JAVAC				=$(JDK)\VisualCafePDE\bin\sj
JAVAC					=$(TOOLS_DRV)\VisualCafePDE\bin\sj
JDK_LIB				=$(TOOLS_DRV)\jdk\V1.1.6\lib
NWJDK_CLASSES		=$(TOOLS_DRV)\java\classes
JAVALIB				=$(TOOLS_DRV)\java\lib

############### PROVO #################################################

!ELSE    # PROVO_ADG is defined
JDK_116			=$(TOOLS_DRV)\jdk116
JDK_122			=$(TOOLS_DRV)\VC4.5\Java2
JDK_13			=$(TOOLS_DRV)\jdk13
JDK			=$(JDK_13)
JDK_BIN			=$(JDK)\bin
JDK_LIB			=$(JDK)\lib
JAVAC_OLD		=$(TOOLS_DRV)\VisualCafePDE\bin\sj
JAVAC_116		=$(JDK_BIN)\sj
JAVAC_122		=$(JDK_BIN)\..\..\bin\sj
JAVAC_13		=$(JDK_BIN)\javac
JAVAC			=$(JAVAC_13)
JDK_CLASSES_116		=$(JDK_LIB)\classes.zip
JDK_CLASSES_122		=$(JDK_LIB)\rt.jar;$(JDK_LIB)\i18n.jar
JDK_CLASSES_13		=$(JDK_LIB)\jawt.lib;$(JDK_LIB)\jvm.lib
JDK_CLASSES		=$(JDK_CLASSES_13)
JNDI_CLASSES		=..\import\njclv2\jndi.jar
NJCL_CLASSES_116	=..\import\njcl\njcl.jar
NJCL_CLASSES_122	=..\import\njclv2\njclv2.jar
NJCL_CLASSES_13		=..\import\njclv2\njclv2.jar
NJCL_CLASSES		=$(NJCL_CLASSES_13)
NDPS_CLASSES_10		=..\import\java\ndps.jar
NDPS_CLASSES		=$(NDPS_CLASSES_10)
NPS_LIB_DIR		=..\..\appbase\final\production\sys\webapps\nps\web-inf\lib
NPS_CLASSES_DIR		=..\import\nps
NPS_CLASSES		=..\..\appbase\s_java\jar\release\bomanps\bomanps.jar;$(NPS_LIB_DIR)\nps.jar;$(NPS_LIB_DIR)\nxsl.jar;$(NPS_LIB_DIR)\cos.jar;..\import\java\xerces.jar
CONSOLEONE_DIR		=..\..\appbase\final\production\sys\public\mgmt\consoleone\1.2
MACH_DIR		=$(CONSOLEONE_DIR)\snapins\mach
CORE_DIR		=$(CONSOLEONE_DIR)\lib\core
SECURITY_DIR		=$(CONSOLEONE_DIR)\lib\security
NI_DIR			=..\..\appbase\final\production\sys\ni\update\lib
AFP_CLASSES		=$(MACH_DIR)\MACH.jar;$(CORE_DIR)\NDSNamespace.jar;$(MACH_DIR)\JNDINDS.jar;$(CONSOLEONE_DIR)\ConsoleOneCore.jar;$(SECURITY_DIR)\NMASToolkit.jar;$(NI_DIR)\ni.jar;

!ENDIF   # PROVO_ADG

JAVAH					=$(JDK_BIN)\javah

############### SETUP Path and Classpath ##############################

PATH		=.;$(TOOLS_DRV)\misc;$(JDK_BIN);$(PATH)
CLASSPATH	= .;..\s_java;$(JDK_CLASSES);$(JNDI_CLASSES);$(NJCL_CLASSES);..\misc;$(AFP_CLASSES);$(NDPS_CLASSES);$(NPS_CLASSES)

!IFDEF PATH
OPATH=$(PATH)
!ENDIF


MISC_PATH=$(TOOLS_DRV)\misc

# Default build tools
# ----
COMP_CMD				=$(CONTINUE)$(SILENT_CMD)wcc386
#CPLUS_CMD			=$(CONTINUE)$(SILENT_CMD)wcpp386
COMP_CPP_CMD		=$(CONTINUE)$(SILENT_CMD)wpp386
WLINK_CMD			=makeexec wlink
WATC_DISASM_CMD	=$(SILENT_CMD)$(CONTINUE)makeexec wdisasm
WATCOM				=$(TOOLS_DRV)\watcom\v11
COMP_PATH			=$(WATCOM)\binnt;$(WATCOM)\binw
GREP					=$(MISC_PATH)\grep.exe
SED					=$(MISC_PATH)\sed.exe
COPY					=$(MISC_PATH)\krcp32.exe
COPY_FLAGS			=/cdr
COPY_CMD				=-1$(SILENT_CMD)$(COPY) $(COPY_FLAGS)
COPYSUB_CMD				=-1$(SILENT_CMD)$(COPY) $(COPY_FLAGS)s
MAKE					=$(MISC_PATH)\nmake.exe
MAKE_FLAGS			=-nologo
MAKE_CMD				=$(SILENT_CMD)$(MAKE) $(MAKE_FLAGS)
# Backward compatability -- switching from krdel to krdel32
!IF EXIST ($(MISC_PATH)\krdel32.exe)
DEL					=$(MISC_PATH)\krdel32.exe
DEL_FLAGS			=/HSR /-P
DEL_CMD				=-1$(SILENT_CMD)$(DEL) $(DEL_FLAGS)
DELTREE				=$(DEL_CMD) /hsz
!ELSE
!IF "$(OS)" == "Windows_NT"
DEL					=$(MISC_PATH)\krdel.exe
DEL_FLAGS			=/aq
DEL_CMD				=$(SILENT_CMD)$(DEL) $(DEL_FLAGS)
DELTREE				=$(DEL_CMD) /se
!ELSE
DEL					=del
DEL_FLAGS			=
DEL_CMD				=$(SILENT_CMD)$(DEL) $(DEL_FLAGS)
DELTREE				=deltree /y
!ENDIF
!ENDIF
CD						=$(SILENT_CMD)cd
SET					=$(SILENT_SET)set
JAR_CMD				=$(SILENT_CMD)makeexec $(JDK_BIN)\jar
ZIP_CMD				=$(SILENT_CMD)makeexec $(MISC_PATH)\pkzip.exe
JAVAC_CMD			=$(SILENT_CMD)$(JAVAC) $(JAVAC_FLAGS)
JAVAH_CMD			=$(SILENT_CMD)$(JAVAH) $(JAVAH_FLAGS)

#LINKER_CMD			=$(CONTINUE)$(SILENT_CMD)makeexec nlmlinkx
LINKER_CMD			=$(CONTINUE)$(SILENT_CMD)makeexec wlink
#LINKER_PATH		=$(TOOLS_DRV)\nlink\vx279
LINKER_PATH			=$(WATCOM)\binnt

ASM_CMD				=$(CONTINUE)$(SILENT_CMD)386asm
ASM_PATH				=$(TOOLS_DRV)\pharlap\v40

BTRIEVE_LOAD_CMD	=$(SILENT_CMD)btrieve /p:1536
BTRIEVE_UNLOAD_CMD=$(SILENT_CMD)butil -stop
BTRIEVE_PATH		=$(TOOLS_DRV)\btrieve\v510

MSGTOOLS_PATH		=$(TOOLS_DRV)\msgtools\v5.1

MIBCOMP_CMD			=$(SILENT_CMD)mibcomp
MIBCOMP_PATH		=$(TOOLS_DRV)\mibcomp\v2.2

TOOL_PATH			=$(COMP_PATH);$(ASM_PATH);$(LINKER_PATH);$(MSGTOOLS_PATH);$(BTRIEVE_PATH);$(MIBCOMP_PATH);$(MISC_PATH)
!IFDEF RDEBUG
TOOL_PATH			=$(TOOLS_DRV)\rdebug;$(TOOL_PATH)
USE_WLINK			=1
!ENDIF

#WATCOM compiler flags
#-3r           386 register calling conventions
#-3s           386 stack calling conventions
#-4r           486 register calling conventions
#-4s           486 stack calling conventions
#-5r           Pentium register calling conventions
#-5s           Pentium stack calling conventions
#-6r           Pentium Pro register calling conventions
#-6s           Pentium Pro stack calling conventions
#-aa           allow non const initializers for local aggregates or unions
#-ai           turn off type checking on static initialization
#-aq           turn off qualifier mismatch warning for const/volatile
#-bd           build target is a dynamic link library (DLL)
#-bm           build target is a multi-thread environment
#-br           build with dll run-time library
#-bt=<id>      build target for operating system <id>
#-bw           build target is a default windowing application
#-d<id>[=text] precompilation #define <id> [text]
#-d0           no debugging information
#-d1{+}        line number debugging information
#-d2           full symbolic debugging information
#-d3           full symbolic debugging with unreferenced type names
#-d+           allow extended -d macro definitions
#-db           generate browsing information
#-e=<num>      set limit on number of error messages
#-ee           call epilogue hook routine
#-ef           use full pathnames in error and warning messages
#-ei           force enums to be at least as large as an int
#-em           force enum base type to use minimum integral type
#-en           emit routine names in the code segment
#-ep[=<num>]   call prologue hook routine with <num> stack bytes available
#-eq           do not display error messages (they are still written to a file)
#-et           P5 profiling
#-ez           generate PharLap EZ-OMF object files
#-fh[=<file>]  use pre-compiled headers
#-fhq[=<file>] do not display pre-compiled header activity warnings
#-fi=<file>    force <file> to be included
#-fo[=<file>]  set object or preprocessor output file name
#-fr[=<file>]  set error file name
#-fp2          generate 287 floating-point code
#-fp3          generate 387 floating-point code
#-fp5          optimize floating-point for Pentium
#-fp6          optimize floating-point for Pentium Pro
#-fpc          calls to floating-point library
#-fpi          inline 80x87 instructions with emulation
#-fpi87        inline 80x87 instructions
#-fpr          generate backward compatible 80x87 code
#-g=<id>       set code group name
#-hc           generate Codeview debugging information
#-hd           generate DWARF debugging information
#-hw           generate Watcom debugging information
#-i=<path>     add another include path
#-j            change char default from unsigned to signed
#-mc           compact memory model (small code/large data)
#-mf           flat memory model (small code/small data assuming CS=DS=SS=ES)
#-ml           large memory model (large code/large data)
#-mm           medium memory model (large code/small data)
#-ms           small memory model (small code/small data)
#-nc=<id>      set code class name
#-nd=<id>      set data segment name
#-nm=<file>    set module name
#-nt=<id>      set name of text segment
#-o{a,b,c,d,e,f[+],h,i,k,l,m,n,o,p,r,s,t,u,x,z} control optimization
#  a           -> relax aliasing constraints
#  b           -> branch prediction
#  c           -> disable <call followed by return> to <jump> optimization
#  d           -> disable all optimizations
#  e[=<num>]   -> expand user functions inline (<num> controls max size)
#  f           -> generate traceable stack frames as needed
#  f+          -> always generate traceable stack frames
#  h           -> enable expensive optimizations
#  i           -> expand intrinsic functions inline
#  k           -> push register saves into flow graph
#  l           -> enable loop optimizations
#  l+          -> enable loop unrolling optimizations
#  m           -> generate inline code for math functions
#  n           -> allow numerically unstable optimizations
#  o           -> continue compilation if low on memory
#  p           -> generate consistent floating-point results
#  r           -> reorder instructions for best pipeline usage
#  s           -> favor code size over execution time in optimizations
#  t           -> favor execution time over code size in optimizations
#  u           -> all functions must have unique addresses
#  x           -> equivalent to -obmilker -s
#  z           -> NULL points to valid memory in the target environment
#-p{c,l,w=<num>} preprocess source file
#  c           -> preserve comments
#  l           -> insert #line directives
#  w=<num>     -> wrap output lines at <num> columns. Zero means no wrap.
#-r            save/restore segment registers across calls
#-ri           return chars and shorts as ints
#-s            remove stack overflow checks
#-sg           generate calls to grow the stack
#-st           touch stack through SS first
#-tp=<id>      set #pragma on( <id> )
#-u<id>        undefine macro <id>
#-v            output function declarations to .def
#-vcap         VC++ compatibility: alloca allowed in argument lists
#-w=<num>      set warning level number
#-wcd=<num>    warning control: disable warning message <num>
#-wce=<num>    warning control: enable warning message <num>
#-we           treat all warnings as errors
#-za           disable extensions (i.e., accept only ISO/ANSI C)
#-zc           place literal strings in the code segment
#-zdf          DS floats i.e. not fixed to DGROUP
#-zdp          DS is pegged to DGROUP
#-zdl          Load DS directly from DGROUP
#-ze           enable extensions (i.e., near, far, export, etc.)
#-zff          FS floats i.e. not fixed to a segment
#-zfp          FS is pegged to a segment
#-zgf          GS floats i.e. not fixed to a segment
#-zgp          GS is pegged to a segment
#-zg           generate function prototypes using base types
#-zk0          double-byte character support: Kanji
#-zk0u         translate double-byte Kanji to Unicode
#-zk1          double-byte character support: Chinese/Taiwanese
#-zk2          double-byte character support: Korean
#-zku          double-byte character support: local installed language
#-zku=<num>    load UNICODE translate table for specified code page
#-zl           remove default library information
#-zld          remove file dependency information
#-zm           place each function in separate segment
#-zp=<num>     pack structure members with alignment {1,2,4,8,16}
#-zpw         output warning when padding is added in a struct
#-zq           operate quietly
#-zs           syntax check only
#-zt[=<num>]   set far data threshold (i.e., larger objects go in far memory)
#-zu           SS != DGROUP (i.e., don't assume stack is in your data segment)
#-zw           generate code for Microsoft Windows

# default flags to give C commands.
# ----
#CFLAG_PROD			=/d_WATCOMC_=1 /mf /s /oabeihkl+rt /6s /w4 /ei /ez /ze /zq /zp1 /zm /zg
#CFLAG_DEBUG		=/d_WATCOMC_=1 /mf /s /oabeihklrt /6s /w4 /ei /ez /ze /zq /zp1 /zg /zm
CFLAG_PROD			=/dWATCOM /dWATCOM11 /d_WATCOMC_=1 /dNETWARE /dN_PLAT_NLM /dXP_NETWARE /dx86 /dTRACING\
				/mf /s /ri /oabeihkl+rt /6s /w4 /ei /ez /ze /zq /zp1 /zm /fpi87 /zl

!IFDEF RDEBUG
CFLAG_DEBUG			=$(CFLAG_PROD) /hc /d2
!ELSE
CFLAG_DEBUG			=$(CFLAG_PROD)
!ENDIF

!IFDEF PRODUCTION
CFLAGS				=$(CFLAG_PROD)
!ELSE
CFLAGS				=$(CFLAG_DEBUG)
!ENDIF

# Because we cannot do an UNDEF of a symbol (OMAKE bug), we need to define another macro which can
# do the negation. We will then override the CFLAGS based on the new macro (NOPRODUCTION)
!IFDEF NOPRODUCTION
CFLAGS				=$(CFLAG_DEBUG)
!ENDIF

!IFDEF TIMEBOMB
CFLAGS				=$(CFLAGS) /dTIMEBOMB=$(TIMEBOMB)
!ENDIF

# Default Phar-Lap assembler flags
# (fullwarn, twocase, nolist, errlist)
# ----
AFLAGS				=-fw -tc -nol -el $*.err -o $*.obj
CFLAGS				=$(CFLAGS) /dIAPX386

#
# general C rule, really nothing but a bunch of macro references.
#   errors are forced into an error file, so although the
#   make will stop, you have to refer to the file.  this command
#   can be used in conjunction with ".PATH.c" to compile files
#   from other directories into object files in the current
#   directory.
# ----
{$(ROOT)\S_CMDLIN}.c.obj:
    $(SILENT_SETFLAGS)set WCC386=$(CFLAGS) $(CXFLAGS)
    $(SILENT_SET)set INC386=$(INC_SEMI)
    $(SILENT_SET)set WCGMEMORY=4096
    -@echo Building $@
    $(COMP_CMD) $<

#{$(ROOT)\S_AUTOVOL}.c.obj:
#    $(SILENT_SETFLAGS)set WCC386=$(CFLAGS) $(CXFLAGS)
#    $(SILENT_SET)set INC386=$(INC_SEMI)
#    $(SILENT_SET)set WCGMEMORY=4096
#    -@echo Building $@
#    $(COMP_CMD) $<

{$(ROOT)\S_ADDRCHK}.c.obj:
    $(SILENT_SETFLAGS)set WCC386=$(CFLAGS) $(CXFLAGS)
    $(SILENT_SET)set INC386=$(INC_SEMI)
    $(SILENT_SET)set WCGMEMORY=4096
    -@echo Building $@
    $(COMP_CMD) $<

{$(ROOT)\S_CHKFLOP}.c.obj:
    $(SILENT_SETFLAGS)set WCC386=$(CFLAGS) $(CXFLAGS)
    $(SILENT_SET)set INC386=$(INC_SEMI)
    $(SILENT_SET)set WCGMEMORY=4096
    -@echo Building $@
    $(COMP_CMD) $<

# rule for phar-lap assembler.  By convention, we use .asm extention for
# these sources.
# ----
{$(ROOT)\S_PROXY}.asm.obj:
!IFDEF PROVO_ADG
    -@echo Building $@
!ELSE
    -@echo Building $@--Flags $(AFLAGS) $(AXFLAGS)
!ENDIF
    $(ASM_CMD) $< @<<$(*R).tmp
$(AFLAGS) $(AXFLAGS) -i $(INC_COMMA)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF
!IFDEF CONTINUE
	-$(SILENT_CMD)test3err $*.err
!ENDIF

!IFDEF MAKE_MESSAGES
# Only make messages if explicitly requested. This is so Engineers can
# build the messages when changes occur, check them in, and they will not
# need rebuilding. Otherwise, the MDBs and MSGs keep getting rebuilt in
# the PREP areas causing messages ad MDBs to change out of control and
# cause problems determining which versions need translating.


# Create FAKE JAPANESE message file from a message database. We are
# loading/unloading btrieve on the fly within the makefile. So it may
# complain "trouble executing command" if there is not enough memory
# to load btrieve.
# ----
{$(MDB_DIR)}.mdb{$(WIDEJP_DIR)}.msg:
    -@echo Building Wide Roman $@
    <<$(TARGET).bat
@echo off
$(BTRIEVE_LOAD_CMD)
copy $< tmp.mdb >nul
msglabel tmp.mdb $(NLM) $(MDB_VERS) $(WIDE_ROMAN_TEST) $(TRANSLATION_REVISION)
msgtran tmp.mdb wideroman
msgexp tmp.mdb msglib nlm $@ /t
del tmp.mdb >nul
$(BTRIEVE_UNLOAD_CMD)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF

# Create FAKE EUROPEAN message file from a message database. We are
# loading/unloading btrieve on the fly within the makefile. So it may
# complain "trouble executing command" if there is not enough memory
# to load btrieve.
# ----
{$(MDB_DIR)}.mdb{$(EUROPE_DIR)}.msg:
    -@echo Building European $@
    <<$(TARGET).bat
@echo off
$(BTRIEVE_LOAD_CMD)
copy $< tmp.mdb >nul
msglabel tmp.mdb $(NLM) $(MDB_VERS) $(EURO_TEST) $(TRANSLATION_REVISION)
msgtran tmp.mdb europe
msgexp tmp.mdb msglib nlm $@ /t
del tmp.mdb >nul
$(BTRIEVE_UNLOAD_CMD)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF

# Create WORDCOUNT file from a message database. We are
# loading/unloading btrieve on the fly within the makefile. So it may
# complain "trouble executing command" if there is not enough memory
# to load btrieve.
# ----
{$(MDB_DIR)}.mdb{$(WORD_COUNT_DIR)}.cnt:
    -@echo Building Word Count $@
    <<$(TARGET).bat
@echo off
$(BTRIEVE_LOAD_CMD)
copy $< tmp.mdb >nul
msggloss tmp.mdb /m /x >$@
del tmp.mdb >nul
$(BTRIEVE_UNLOAD_CMD)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF

# Create ENGLISH message file from a message database. We are
# loading/unloading btrieve on the fly within the makefile. So it may
# complain "trouble executing command" if there is not enough memory
# to load btrieve. Since building the MDB added an is_product flag, we
# need to remove it since it confuses the CCM database
# ----
{$(MDB_DIR)}.mdb{$(MESSAGE_DIR)}.msg:
    -@echo Building English $@
    <<$(TARGET).bat
@echo off
$(BTRIEVE_LOAD_CMD)
copy $< tmp.mdb >nul
msglabel tmp.mdb $(NLM) $(MDB_VERS) $(LANGUAGE) $(TRANSLATION_REVISION)
msgtran tmp.mdb null
msgexp tmp.mdb msglib nlm $@
del tmp.mdb >nul
$(BTRIEVE_UNLOAD_CMD)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF

# update a message database file from a msglib maintain message file.
# note that message database files are *source*, so there's nothing
# here to create and label one.  That's a development problem as much
# as, say, running msglib to create the mlc file.
# We are loading/unload btrieve on the fly within the makefile. So it may
# complain "trouble executing command" if there is not enough memory to
# load btrieve.
# ----
{$(MDB_DIR)}.mlc{$(MDB_DIR)}.mdb:
    -@echo Building Message Database $@
    <<$(TARGET).bat
@echo off
$(BTRIEVE_LOAD_CMD)
msglabel $@ $(NLM) $(MDB_VERS) $(LANGUAGE) $(TRANSLATION_REVISION)
msgimp $@ mlc $<
$(BTRIEVE_UNLOAD_CMD)
!IFDEF KEEP_FILES
<<KEEP
!ELSE
<<NOKEEP
!ENDIF

.SUFFIXES : .asm .mlc .mdb .msg .cnt

# End of IFEDF MAKE_MESSAGES
!ELSE

# If we are not making messages, we need to kill the MSGs etc
# being build targets, otherwise, it tries to make some bogus
# descision that the target needs building and has no way to
# build it.
.SUFFIXES : .asm

!ENDIF

start:      init $(TARGET) end

init:
    @echo Building $(TARGET) . . .
!IFNDEF DRV_MAPPED
! IFDEF VERBOSE
!  IFNDEF TOOLS_SERVER
    -@echo Environment variable TOOLS_SERVER is not set
    -@echo Setting TOOLS_SERVER to $(DEFAULT_TOOLS_SERVER)
!  ELSEIFNDEF PROVO_ADG
    -@echo Setting TOOLS_SERVER to $(DEFAULT_TOOLS_SERVER)
!  ELSE
    -@echo Environment variable TOOLS_SERVER is set to $(TOOLS_SERVER)
!  ENDIF
! ENDIF
	$(SILENT_CMD)$(MAP_TOOLS_CMD)
	$(SET) PATH=$(TOOL_PATH);$(PATH)
!ELSEIFNDEF PATH_SET
	$(SET) PATH=$(TOOL_PATH);$(PATH)
!ENDIF

end:
    -@echo Completed build of $(TARGET)
