#include "rsync.h"

#include <stdio.h>
#include <unistd.h>
#include <locale.h>
#include <dirent.h>
#include <signal.h>
#include <errno.h>
#include <errno.h>
#include <time.h>
#include <semaphore.h>
#include <screen.h>
#include <netware.h>
#include <nks/thread.h>
#include <nks\netware.h>
#include "nwreg.h"
#include "popt.h"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef SUCCESS
#define SUCCESS 0
#endif

#ifndef SUCCESS_NO_CHANGE
#define SUCCESS_NO_CHANGE 1
#endif

#ifndef FAIL
#define FAIL -1
#endif

#define ESUCCESS 0
#define EFAILURE (-1)

#define SELECT_TIMEOUT 60

int m_server_fd;
int volatile m_NLM_shutdown;
int volatile m_NLM_threadCount;
int m_mainThreadGroupID;
semaphore* m_RecvSemaphore = NULL;
semaphore* m_NamedSemaphore = NULL;
//TSD Tsd;
int gInited;
scr_t gScreenHandle;
scr_t  gScoreHandle;
scr_t  myErrorScreen;
long myModuleHandle;
pthread_key_t tsdKey;
UniRuleTable_t	uni_table;
unsigned int 	g_cpuCount;
unsigned int	g_cpuBind = 0;
int gLogged;

typedef struct
{
   sem_t sem;
   int   value;
} nwsem_t;

nwsem_t *g_sem;
unsigned int	g_slot = 0;
int ap_thread_stack_size=65536;

extern int g_no_mp;

#define STREDIT_NOFLAGS	0x00000000	/* Just to be thourough						*/
#define STREDIT_NEW		0x00000001  /* Zero's out the strBuf before editing.*/
#define STREDIT_NOECHO	0x00000002	/* Does not echo to the screen.		 	*/
#define STREDIT_ECHOAS	0x00000004	/* Echos astricts.						 	*/
#define STREDIT_UPPER	0x00000008	/* Upper-case alpha.						 	*/

#define STREDIT_ERR_TOOLONG	(-1)
#define STREDIT_KEY_ESC			27
#define STREDIT_KEY_ENTER		13
#define STREDIT_KEY_BACKSPACE 8

void initMPSystem()
{
	g_cpuCount = NXGetCpuCount ();
//	printf("MP system cpu %d\n", g_cpuCount);
}

NXCpuId_t bindMPThread(int flag)
{
	get_tsd
	int rc;
	NXCpuId_t binding;
	
	if (g_no_mp)
	{
		binding = 0;
		rc = NXThreadBind ( binding);
		if (rc)
			rprintf(FLOG, "Error:  bindMPThread %d %d, unable to bind to requested CPU\n", rc, g_cpuBind);
		
		binding = NXThreadGetBinding ( );
		if (rc)
			rprintf(FLOG, "Error:  bindMPThread %d %d, unable to verify the binding to requested CPU\n", rc, binding);
			
		return binding;
	}
	
	if (g_cpuCount < 2)
		return;
	
	if (flag != NX_MYCPUID)
	{	
		if (g_cpuBind < g_cpuCount-1)
			g_cpuBind++;
		else
			g_cpuBind = 0;
			
		binding = g_cpuBind;
	}
	else
	{
		binding = tsd->bound_cpu;
	}
		
//	printf("bindMPThread %d %d\n", g_cpuBind, binding);
		
	rc = NXThreadBind ( binding);
	if (rc)
		rprintf(FLOG, "Error:  bindMPThread %d %d, unable to bind to requested CPU\n", rc, g_cpuBind);
	
	binding = NXThreadGetBinding ( );
	if (rc)
		rprintf(FLOG, "Error:  bindMPThread %d %d, unable to verify the binding to requested CPU\n", rc, binding);
		
	return binding;
}

int StringEdit(char *strBuf, int maxStrLen, int flags, char *prompt)
{
	int 	ch;

	/*------------------------------------------------------------------------
	**	New buffer?
	*/
	if(flags & STREDIT_NEW) memset(strBuf, 0x00, maxStrLen);

	/*------------------------------------------------------------------------
	**	Check args.
	*/
	if(strlen(strBuf) > maxStrLen - 1) return(STREDIT_ERR_TOOLONG);

	/*------------------------------------------------------------------------
	**	Print the prompt & current strBuf value..
	*/
	if(prompt != NULL) printf("%s%s", prompt, strBuf);

	/*------------------------------------------------------------------------
	**	Handle keyboard.
	*/
	while(1)
		{
		ch=getch(); if(!ch) ch=getch() + 256;
		if((ch < 32) || (ch == 127) || (ch > 255)) /* Control chars & Function Keys	*/
		{
			switch(ch)
			{
				case STREDIT_KEY_ESC:
				case STREDIT_KEY_ENTER:
					printf("\n");
					return(ch);

				case STREDIT_KEY_BACKSPACE:
					if(strlen(strBuf) == 0) continue;
					strBuf[strlen(strBuf)-1] = '\0';
					printf("\b \b");
					continue;
			}

			continue;
		}
		else if(ch <= 126)							    /* -Normal- characters */
		{
			if(strlen(strBuf) == (maxStrLen -1)) 
				continue;
			if(flags & STREDIT_UPPER) if(islower(ch)) ch -= 32;
			strBuf[strlen(strBuf)+1] = '\0';
			strBuf[strlen(strBuf)] = (char)ch;
			if(!(flags & STREDIT_NOECHO))
			{
				if(flags & STREDIT_ECHOAS) 
					printf("*");
				else 
					printf("%c", (char)ch);
			}
			continue;
		}
 		else 
 			continue;					    /* Extended chars from 128 - 255 */
	}
}

char *getpass(const char *filename)
{
	char	operatorPassWord[47+1];
	char *outPass = NULL;

//	getpassword( "", operatorPassWord, sizeof (operatorPassWord) );
//	outPass = strdup(operatorPassWord);
//	memset(operatorPassWord, 0x00, sizeof(operatorPassWord));
	return outPass;
}

int getpid()
{
	return pthread_self();
}


uid_t getuid()
{
	return 1;
}

int getgroups(int ngroups, void *gidset)
{
	return 0;
}

int chroot(const char *dirname)
{
	return 0;
}

int chown(const char *path, uid_t owner, gid_t group)
{
	int rcode = 0;
	return rcode;
}

#ifdef WATCOM
int symlink(const char *file1, const char *file2)
{
	return 0;
}
#endif


int fork()
{
	return 0;
}

int kill(pid_t pid, int signal)
{
	return 0;
}

thread *create_thread(void (thread_fn)(void *), void *thread_arg)
{
	pid_t	thr_id;
//	char threadname[20];	
	pthread_attr_t    attr;
	
	pthread_attr_init(  &attr);

	pthread_attr_setstacksize(&attr, 65536);
	
//	sprintf(threadname,"rsync receiver");
//	pthread_attr_setname_np(&attr, threadname,NULL);

	if (pthread_create(&thr_id, &attr, (void *(*)(void *))thread_fn,(void *) thread_arg) > 0)
	{
		return (thread*)NULL;
	}
    
    return((thread *)thr_id);
}

thread *create_threadgroup(void (thread_fn)(void *), void *thread_arg)
{
	pid_t	thr_id;
//	char threadname[20];
	pthread_attr_t    attr;
	
	pthread_attr_init(  &attr);

	pthread_attr_setstacksize(&attr, 65536);

//	sprintf(threadname,"rsync generator");
//	pthread_attr_setname_np(&attr, threadname,NULL);
	
	if (pthread_create(&thr_id, &attr, (void *(*)(void *))thread_fn,(void *) thread_arg) > 0)
	{
		return (thread*)NULL;
	}
    
    return((thread *)thr_id);
}

int kill_thread(thread *thread_id)
{
    return(0);
}

int await_thread(thread *thread_id, int sec_to_wait)
{
    return(0);
}

void exit_thread(int status)
{}

void free_thread(thread *thread_id)
{}

#if 0
mutex * ap_create_mutex(char *name)
{
    return (mutex*)kMutexAlloc(name);
}

mutex * ap_open_mutex(char *name)
{
	return(NULL);
}

int ap_acquire_mutex(mutex *mutex_id)
{
    return(kMutexLock(mutex_id));
}

int ap_release_mutex(mutex *mutex_id)
{
    if (kMutexUnlock(mutex_id))
        return 0;
    else
        return 1;
}

void ap_destroy_mutex(mutex *mutex_id)
{
    kMutexFree(mutex_id);
}
#endif

semaphore *create_semaphore(int initial)
{
	int rc;
	semaphore* rv = NULL;
	sem_t *sem = (sem_t*)malloc(sizeof (sem_t));
	if (!sem)
		out_of_memory("create_semaphore");
		
	rc = sem_init   ( sem, 0, initial );
	if (rc == 0)
	{
		rv = (semaphore*)sem;
//		consoleprintf("%d create_semaphore(%x) => %d\n", getpid(), rv, initial);
	}
	else
	{
		free(sem);
		rv = NULL;
	}
	return rv;
}

int acquire_semaphore(semaphore *semaphore_id)
{
	int rc;
	rc = sem_wait(semaphore_id);
	if (rc != 0)
	{
		consoleprintf( "%d acquire_semaphore(%x) failed => %d\n", getpid(), semaphore_id, errno);
	}
	return rc;
}

int release_semaphore(semaphore *semaphore_id)
{
	int rc;
	rc = sem_post(semaphore_id);
	if (rc != 0)
	{
		consoleprintf("%d release_semaphore(%x) failed => %d\n", getpid(), semaphore_id, errno);
	}
	return rc;
}

int destroy_semaphore(semaphore *semaphore_id)
{
	int rc;
//	consoleprintf("%d destroy_semaphore(%x)\n", getpid(), semaphore_id);
	if (semaphore_id)
	{
		rc = sem_destroy(semaphore_id);
		free(semaphore_id);
		return rc;
	}
	else
	{
		consoleprintf( "%d destroy_semaphore() failed => NULL semaphore\n", getpid());		
		return 1;
	}
}

int named_semaphore(int signal)
{
	if (g_sem)
	{
		switch(signal)
		{
			case SIGKILL:
//			consoleprintf("Received kill %d\n", getpid());
			g_sem->value++;
			return g_sem->value;
		
			default:
				return -1;
		}
	}
	else
		return -1;
}

semaphore *create_namedsemaphore(const char* semaphoreName, int initialValue)
{
	g_sem = (nwsem_t*)malloc(sizeof (nwsem_t));
	memset(g_sem, 0x00, sizeof (nwsem_t));
	if (0 == ExportPublicObject(getnlmhandle(), semaphoreName, named_semaphore))
		return (semaphore*)g_sem;
	else
		return NULL;
}

int examine_namedsemaphore(semaphore *semaphore_id)
{
	if (g_sem)
	{
		if (g_sem->value != 0)
			return 1;
		else
			return -128;
	}
}

void destroy_namedsemaphore(semaphore *semaphore_id)
{
	if (semaphore_id)
		free(semaphore_id);
	else
		consoleprintf( "%d destroy_namedsemaphore() failed => NULL semaphore\n", getpid());		
}

int getRsyncSocketName(int socket, char *name)
{
   struct sockaddr_in Addr;
   char AddrString[128];
   DWORD AddrStringLength;
   AddrStringLength = 128;

   AddrStringLength = sizeof(struct sockaddr_in);

   if (getsockname(socket, (SOCKADDR *)&Addr,
      (int *)&AddrStringLength))
   {
      rprintf(FLOG, "Error in getsockname %d\r\n", WSAGetLastError());
      goto Err;


   }

   AddrStringLength = 128;

   if (WSAAddressToStringA((SOCKADDR *)&Addr,sizeof(struct sockaddr_in), NULL,
      AddrString, &AddrStringLength))
   {
      rprintf(FLOG, "Error in WSAAddressToString\r\n");
      goto Err;

   }

   strcpy(name, AddrString);
   return 0;
   
Err:
   return(-1);
}

void initTsdVariables(TSD * tsd)
{
    memset(tsd, 0, sizeof(TSD));

	verbose=0;
	whole_file = -1;
	module_id = -1;
	block_size=0;
	blocking_io=-1;
	csum_length=2;
	compression_level = Z_DEFAULT_COMPRESSION;
	last_token=-1;
	backup_suffix = NULL;
	files_from = NULL;
	
	batch_fd = -1;
	batch_gen_fd = -1;
	filesfrom_fd = -1;
	io_filesfrom_f_in = -1;
	io_filesfrom_f_out = -1;
	sock_f_in = -1;
	sock_f_out = -1;
	msg_fd_in = -1;
	msg_fd_out = -1;
	write_batch_monitor_in = -1;
	write_batch_monitor_out = -1;
	select_timeout = SELECT_TIMEOUT;
	tsd->rfe_lastdir_len = -1;
	tsd->mf_lastdir_len = -1;
	f_csums = -1;
	f_delta = -1;
	remote_filesfrom_file = NULL;
	protocol_version = PROTOCOL_VERSION;
	remote_filesfrom_file = NULL;
	relative_paths = -1;
	implied_dirs = 1;
	eol_nulls = 0;
	bInGlobalSection = True;
	
	exclude_list.head = exclude_list.tail = 0;
	exclude_list.debug_type = "";
	
	local_exclude_list.head = local_exclude_list.tail = 0;
	local_exclude_list.debug_type = "per-dir .cvsignore ";
	
	server_exclude_list.head = server_exclude_list.tail = 0;
	server_exclude_list.debug_type = "server ";

	tsd->error_pipe[0] = tsd->error_pipe[1] = INVALID_SOCKET;
	tsd->accept_fd = INVALID_SOCKET;
	tsd->threadType = TMAIN;
}

#if 0
void printTsdVariables(TSD * tsd)
{
	rprintf(FLOG, "verbose=%d\n", verbose);
	rprintf(FLOG, "whole_file=%d\n", whole_file);
	rprintf(FLOG, "module_id=%d\n", module_id);
	rprintf(FLOG, "block_size=%d\n", block_size);
	rprintf(FLOG, "blocking_io=%d\n", blocking_io);
	rprintf(FLOG, "csum_length=%d\n", csum_length);
	rprintf(FLOG, "compression_level=%d\n", compression_level);
	rprintf(FLOG, "last_token=%d\n", last_token);

	//backup_suffix = NULL;
	//files_from = NULL;
	rprintf(FLOG, "batch_fd=%d\n", batch_fd);
	rprintf(FLOG, "batch_gen_fd=%d\n", batch_gen_fd);
	rprintf(FLOG, "filesfrom_fd=%d\n", filesfrom_fd);
	rprintf(FLOG, "io_filesfrom_f_in=%d\n", io_filesfrom_f_in);
	rprintf(FLOG, "io_filesfrom_f_out=%d\n", io_filesfrom_f_out);
	rprintf(FLOG, "sock_f_in=%d\n", sock_f_in);
	rprintf(FLOG, "sock_f_out=%d\n", sock_f_out);
	rprintf(FLOG, "msg_fd_in=%d\n", msg_fd_in);
	rprintf(FLOG, "msg_fd_out=%d\n", msg_fd_out);
	rprintf(FLOG, "io_multiplexing_out=%d\n", io_multiplexing_out);
	rprintf(FLOG, "io_multiplexing_in=%d\n", io_multiplexing_in);
	rprintf(FLOG, "remaining=%d\n", remaining);
	rprintf(FLOG, "iobuf_in=%x\n", iobuf_in);
	rprintf(FLOG, "iobuf_in_ndx=%d\n", iobuf_in_ndx);
	rprintf(FLOG, "write_batch_monitor_in=%d\n", write_batch_monitor_in);
	rprintf(FLOG, "write_batch_monitor_out=%d\n", write_batch_monitor_out);
	rprintf(FLOG, "select_timeout=%d\n", select_timeout);
	rprintf(FLOG, "tsd->rfe_lastdir_len=%d\n", tsd->rfe_lastdir_len);
	rprintf(FLOG, "tsd->mf_lastdir_len=%d\n", tsd->mf_lastdir_len);
	rprintf(FLOG, "f_csums=%d\n", f_csums);
	rprintf(FLOG, "f_delta=%d\n", f_delta);
	rprintf(FLOG, "protocol_version=%d\n", protocol_version);
	rprintf(FLOG, "relative_paths=%d\n", relative_paths);
	rprintf(FLOG, "implied_dirs=%d\n", implied_dirs);
	rprintf(FLOG, "eol_nulls=%d\n", eol_nulls);
	rprintf(FLOG, "bInGlobalSection=%d\n", bInGlobalSection);
	rprintf(FLOG, "tsd->error_pipe[0]=%d\n", tsd->error_pipe[0]);
	rprintf(FLOG, "tsd->error_pipe[1]=%d\n", tsd->error_pipe[1]);
	rprintf(FLOG, "tsd->accept_fd=%d\n", tsd->accept_fd);
	rprintf(FLOG, "tsd->threadType=%d\n", tsd->threadType);

}
#endif

void freeTsdVariables(int flag, TSD * tsd)
{
	extern int am_daemon;

	if ((send_recv_semaphore))
	{
		if (generator_send_flag)
		{
			destroy_semaphore(send_recv_semaphore);
			send_recv_semaphore = NULL;
		
			if (tsd->gFlist)
			{
				flist_free(tsd->gFlist);
				tsd->gFlist = NULL;
			}
		}
	}
	else
	{
		if (tsd->gFlist)
		{
			flist_free(tsd->gFlist);
			tsd->gFlist = NULL;
		}
	}
		
	if (tsd->threadParams)
	{
		free(tsd->threadParams);
		tsd->threadParams = NULL;
	}

	if (tsd->rsync_argc > 0)
	{
		int i;
		for(i = 0; i < tsd->rsync_argc; i++)
		{
			free(tsd->rsync_argv[i]);
		}
		if (am_daemon)
			free(tsd->rsync_argv);
		tsd->rsync_argc = 0;
		tsd->rsync_argv = NULL;
	}
	
	if (tsd->argContext)
	{	
		poptContext poptFreeContext(poptContext con);

//		poptResetContext(tsd->argContext);
//	    free(tsd->argContext);

		poptFreeContext(tsd->argContext);
		tsd->argContext = NULL;
	}

	if ((tsd->threadType == TGEN || tsd->threadType == TMAIN) && tsd->trustBarSession)
	{
		//DSFinalize(tsd->trustBarSession);
		tsd->trustBarSession = NULL;
	}
	
	if (DmemRoot)
	{
		dfreeall();
		DmemRoot = NULL;
	}
#ifdef SCOREBOARD
	if (tsd->threadType == TGEN && tsd->sb_handle)
	{
		ap_delete_sb_handle(tsd->sb_handle);
		tsd->sb_handle = NULL;
	}
#endif

	if (!flag)
	{
		int rc;
		if (tsd->accept_fd != INVALID_SOCKET)
		{
			shutdown(tsd->accept_fd, SD_SEND);
			msleep(1);
			rc = closesocket(tsd->accept_fd);
			tsd->accept_fd = INVALID_SOCKET;
		}
				
		if (tsd->error_pipe[0] != INVALID_SOCKET)	
		{
			rc = closesocket(tsd->error_pipe[0]);
			//printf("close socket %d %d %d\n", tsd->accept_fd, rc, WSAGetLastError());
			tsd->error_pipe[0] = INVALID_SOCKET;
		}
		if (tsd->error_pipe[1] != INVALID_SOCKET)	
		{
			rc = closesocket(tsd->error_pipe[1] );
			//printf("close socket %d %d %d\n", tsd->accept_fd, rc, WSAGetLastError());
			tsd->error_pipe[1] = INVALID_SOCKET;
		}
	}
	if (tsd->readEvent)
	{
		WSACloseEvent(tsd->readEvent);
		tsd->readEvent = NULL;
	}
	if (tsd->writeEvent)
	{
		WSACloseEvent(tsd->writeEvent);
		tsd->writeEvent = NULL;
	}
	if (tsd->errorEvent)
	{
		WSACloseEvent(tsd->errorEvent);
		tsd->errorEvent = NULL;
	}
}

void copyTsdVariables(TSD * out, TSD* in)
{
	*out = *in;		
}

void netwareRecvThread(void* arg)
{
	extern const char phase_unknown[];
	netwareThreadRecvParams * pThreadParams;
	int f_in, f_out, rc = 0;
	char *local_name = NULL;
	char storedLocalName[MAXPATHLEN];
	char outdir[PATH_MAX];
	TSD *tsd = (TSD*)calloc(1,sizeof(TSD));
	
	if (!arg)
	{
		rprintf(FLOG, "netwareRecvThread with NULL argument\n");
		return;
	}
		
	m_NLM_threadCount++;

	pThreadParams = (netwareThreadRecvParams*)arg;
	f_in = pThreadParams->f_in;
	f_out = pThreadParams->f_out;
	copyTsdVariables(tsd,&pThreadParams->tsd);

	pthread_setspecific(tsdKey, tsd);
	
	tsd->bound_cpu = bindMPThread( 0 /*NX_MYCPUID */ );
//	printf("Recv thread bound %d\n", tsd->bound_cpu);

	// Because the thread's cwd defaults to SYS:, we need to set it to
	// the CWD of the main thread
//	rprintf(FLOG, "recv currdir = %s\n", curr_dir);
	if (curr_dir[0] != '\0')	
		chdir2(curr_dir);
		
	tsd->threadParams = pThreadParams;
	exclude_list.head = exclude_list.tail = 0;	
	uidlist = NULL;
	gidlist = NULL;
	obuf = NULL;
	cbuf = NULL;
	dbuf = NULL;
	//iobuf_out = NULL;
	//iobuf_out_cnt = 0;
	//iobuf_in = NULL;
	//iobuf_in_siz = 0;
	//iobuf_in_ndx = 0;
	
	cleanup_buf = NULL;
//	iNumServices = 0;
//	ServicePtrs = NULL;
//	tsd->accept_fd = INVALID_SOCKET;	
	tsd->rdt_init_done = 0;
	tsd->sdt_init_done = 0;
	tsd->gFlist = NULL;
	tsd->rsync_argc = 0;
	tsd->rsync_argv = NULL;
	tsd->argContext = NULL;
	tsd->trustBarSession = NULL;
	DmemRoot = NULL;
	csum_length=2;	
	
//	use_lfs = FALSE;
	tsd->threadType = TRECV;

	if( (tsd->readEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}
	if( (tsd->writeEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}
	if( (tsd->errorEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}

//	rprintf(FLOG,"netwareRecvThread(%d) beginning\n", getpid());
	
//	close(pThreadParams->recv_pipe[0]);
//	close(pThreadParams->error_pipe[0]);
#ifdef __NETWARE__
	if (f_in != f_out) closesocket(f_out);
#else
	if (f_in != f_out) close(f_out);
#endif

	/* we can't let two processes write to the socket at one time */
	close_multiplexing_out();

	/* set place to send errors */
	set_msg_fd_out(pThreadParams->error_pipe[1]);

	if (pThreadParams->local_name[0] != 0)
	{
		strlcpy(storedLocalName, pThreadParams->local_name, MAXPATHLEN);
		local_name = storedLocalName;
	}

//	getcwdpath(outdir, NULL, 0);
//	rprintf(FLOG, "currdir %s\n", outdir);
	
	rc = recv_files(f_in,pThreadParams->flist,local_name);
	io_flush(NORMAL_FLUSH);
	pThreadParams->report(f_in);

	send_msg(MSG_DONE, "", 0);
	io_flush(FULL_FLUSH);

#ifdef SCOREBOARD
	ap_decrement_process_counts(0, 0, 1);
	ap_increment_process_stats(0, &stats);
#endif
	threadCleanup(1);
		
//	free(pThreadParams);
	m_NLM_threadCount--;
//	ExitThread(EXIT_THREAD, rc);
}

void netwareForkThread(void* arg)
{
	extern const char phase_unknown[];
	netwareThreadParams * pThreadParams;
	int f_in, f_out, rc = 0;
    int ccode;
//    TSD Tsd;
//    TSD * tsd = &Tsd;
	TSD *tsd = (TSD*)calloc(1, sizeof(TSD));
	
	if (!arg)
	{
		rprintf(FLOG, "netwareForkThread with NULL argument\n");
		return;
	}
	
	m_NLM_threadCount++;
	pThreadParams = (netwareThreadParams*)arg;
	f_in = pThreadParams->f_in;
	f_out = pThreadParams->f_out;
	acquire_semaphore(m_RecvSemaphore);

	initTsdVariables(tsd);
	copyTsdVariables(tsd,&pThreadParams->tsd);

	pthread_setspecific(tsdKey, tsd);
	
	tsd->bound_cpu = bindMPThread(0);
//	printf("Fork thread bound %d\n", tsd->bound_cpu);
	
//    tsd = pthread_getspecific(tsdKey);

	// Because the thread's cwd defaults to SYS:, we need to set it to
	// the CWD of the main thread
//	if (curr_dir[0] != '\0')	
//		chdir(curr_dir);

	tsd->pd_initialised = 0;
	curr_dir[0] = '\0';
	io_error = 0;	
	exclude_list.head = exclude_list.tail = 0;	
	uidlist = NULL;
	gidlist = NULL;
	iobuf_out = NULL;
	iobuf_out_cnt = 0;
	iobuf_in = NULL;
	iobuf_in_siz = 0;
	iobuf_in_ndx = 0;
	obuf = NULL;
	cbuf = NULL;
	dbuf = NULL;
	iNumServices = 0;
	ServicePtrs = NULL;
	tsd->accept_fd = f_in;
	tsd->threadParams = pThreadParams;
	bInGlobalSection = True;
	tsd->rdt_init_done = 0;
	tsd->sdt_init_done = 0;
	tsd->argContext = NULL;
	tsd->rsync_argc = 0;
	tsd->rsync_argv = NULL;
	
//	use_lfs = FALSE;
	DmemRoot = NULL;
	tsd->threadType = TGEN;
	io_filesfrom_f_in = -1;
	io_filesfrom_f_out = -1;
	filesfrom_fd = -1;
	csum_length=2;
	io_write_phase = phase_unknown;
	io_read_phase = phase_unknown;
	tsd->trustBarSession = NULL;

#ifdef SCOREBOARD
	tsd->sb_handle = NULL;
#endif	
	/* we set a 0 umask so that correct file permissions can be
	   carried across */
	//orig_umask = (int)umask(0);
	
	if( (tsd->readEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}
	if( (tsd->writeEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}
	if( (tsd->errorEvent = WSACreateEvent()) == NULL){
		rprintf(FERROR,"Error: %d with call WSACreateEvent()\n", 
				WSAGetLastError());
		return;
	}
	
//    NWLlocaleconv(&lConvInfo);
//    ccode = NWInitUnicodeTables(lConvInfo.country_id, lConvInfo.code_page);
//    if(ccode)
//    {
//        rprintf(FERROR, "TrustBar_Initialize: NWInitUnicodeTables error %d\n", ccode);
//        return;
//    }
	
	rc = pThreadParams->fn(f_in, f_out);
	
	if (tsd->bReleased == FALSE)
		if (m_RecvSemaphore)
		{
			release_semaphore(m_RecvSemaphore);
		}
	
	//io_multiplexing_close();

//	ThreadSwitch();
//	delay(1000);
//	SHUTDOWN(fd);

	threadCleanup(0);
		
	if (verbose > 2)
		rprintf(FLOG, "netwareForkThread(%d) returned %d\n", f_in, rc);

	m_NLM_threadCount--;
//	ExitThread(EXIT_THREAD, rc);
}

void globalDestructor(void *value)
{
	if (value)
	{
		free(value);
		pthread_setspecific(tsdKey, NULL);
	}
}

void init_tsd()
{   
	TSD *tsd ;
	int rc = pthread_key_create(&tsdKey, globalDestructor);
//	printf("THREAD_tsd_setup = %x %d\n", rc, tsdKey);

	if (rc)
		return;

//    memset(&Tsd, 0, sizeof(TSD));
	tsd = (TSD*)calloc(1, sizeof(TSD));
    initTsdVariables(tsd);
    
	pthread_setspecific(tsdKey, tsd);
	//printf("tsd = %x\n", myTSD);
    
}

#if 0
#undef opendir_411
DIR *os_opendir (const char *pathname)
{
	struct stat s;
	DIR *d = opendir_411 (pathname);

    if (d) {
        strcpy (d->d_name, "<<**");
    }

	if (!d) {
		/* Let's check if this is an empty directory */
		if (stat(pathname, &s) != 0)
			return NULL;
		if (!(S_ISDIR(s.st_mode)))
			return NULL; 
		
		/* If we are here, then this appears to be a directory */
		/* We allocate a name */
		d = NULL;
        d = (DIR *)malloc(sizeof(DIR));
        if (d) {
            memset(d, 0, sizeof(DIR));
            strcpy(d->d_name, "**<<");
			d->d_cdatetime = 50;

        }    

  	}

    return d;

}

#undef readdir_411
DIR *os_readdir (DIR *dirP)
{

/*
 * First three if statements added for empty directory support.
 *
 */
    if (  (dirP->d_cdatetime == 50) && (dirP->d_name[0] == '*') &&
       	  (dirP->d_name[2] == '<') )
    {
        strcpy (dirP->d_name, ".");
        strcpy (dirP->d_nameDOS, ".");
        return (dirP);
    }
    else if ((dirP->d_cdatetime == 50) &&
             (dirP->d_name[0] == '.') &&
             (dirP->d_name[1] == '\0')) {
        strcpy (dirP->d_name, "..");
        strcpy (dirP->d_nameDOS, "..");
        return (dirP);
    }
    else if ( (dirP->d_cdatetime == 50) &&
             (dirP->d_name[0] == '.') &&
             (dirP->d_name[1] == '.') &&
             (dirP->d_name[2] == '\0') ) {
        return (NULL);
    }
    else if ((dirP->d_name[0] == '<') && (dirP->d_name[2] == '*')) {
        strcpy (dirP->d_name, ".");
        strcpy (dirP->d_nameDOS, ".");
        return (dirP);
    }
    else if ((dirP->d_name[0] == '.') && (dirP->d_name[1] == '\0')) {
        strcpy (dirP->d_name, "..");
        strcpy (dirP->d_nameDOS, "..");
        return (dirP);
    }
    else
        return readdir_411 (dirP);
}


#undef closedir_510
int os_closedir (DIR *dirP)
{
/*
 * Modified to handle empty directories.
 *
 */

	if (dirP == NULL) {
		return 0;
	}

    if (  (  (dirP->d_cdatetime == 50) && (dirP->d_name[0] == '*') &&
       	  	 (dirP->d_name[2] == '<') 
       	  ) ||
       	  (	 (dirP->d_cdatetime == 50) && (dirP->d_name[0] == '.') &&
       	     (dirP->d_name[1] == '\0')
       	  ) ||
       	  (	 (dirP->d_cdatetime == 50) && (dirP->d_name[0] == '.') &&
       	     (dirP->d_name[1] == '.') && (dirP->d_name[2] == '\0')
       	  )
       )
	{

 	       free(dirP); 
 	       dirP = NULL;
 	       return 0;
 	}
 	else {
	       return closedir_510(dirP);
	}
		

}
#endif

/****************************************************************************
**	Set one bit of mask & attr as specified.
*/
void NLM_SetAttrAndMask(long *attr, long *mask, long bit)
{
	*mask |= bit;
	*attr = *attr & !(bit);
	return;
}

double computeTime() 
{
	time_t nowTime;
	double retTime;
	
	time(&nowTime);

	if (daylightOnOff)
	{
		nowTime += daylightOffset;
	}	
	
	retTime = 1000.0 * nowTime;
	return retTime;
}

time_t computeCurrentTime()
{
	time_t nowTime;
	
	time(&nowTime);

	if (daylightOnOff)
	{
		nowTime += daylightOffset;
	}	
	return nowTime;
}

void GetRsyncVolumeKey(char *buffer, int maxSize)
{
	extern char *g_volume;
	extern int am_daemon;
	char currentdir[MAXPATHLEN];	
	char server[MAXPATHLEN];
	char volume[MAXPATHLEN];
	char directories[MAXPATHLEN];
	char name[MAXPATHLEN];
	char ext[MAXPATHLEN];
	int elements, flags;
	
	strcpy(volume,"SYS");

//	if (!gInited || !g_volume || stricmp(g_volume,"SYS") == 0 )
	if (am_daemon || !g_volume || (g_volume && stricmp(g_volume,"SYS")== 0 ))
	{
		getcwdpath(currentdir, 0,0);
		deconstruct(currentdir, server, volume, directories, name, ext, &elements, &flags);
		sprintf(buffer, "%s\\%s", REGISTRYKEY_RSYNC_SYS, volume);
		return;
	}
		
	if (g_volume)
	{
		deconstruct(g_volume, server, volume, directories, name, ext, &elements, &flags);
	}
	else
	{
		getcwdpath(currentdir, 0,0);
		deconstruct(currentdir, server, volume, directories, name, ext, &elements, &flags);
	}

	sprintf(buffer, "%s\\%s", REGISTRYKEY_RSYNC, volume);
}

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int IsBOMA()
{
#define    	REGISTRYKEY_APPLIANCE			"Appliance"
#define		REGISTRYVALUE_BOMA_VERSION		"Version"

	static	int iInit = FALSE;
	static 	int iResult = FAIL;
	long	lResult;
	HKEY	hkeyMyKey;
	char 	buf[100];
	long	lSize = sizeof(buf);
	long 	Type;

	if (iInit == FALSE)
	{
		iInit = TRUE;
		// Create or open the registry key
		lResult = RegOpenKeyEx(
						HKEY_LOCAL_MACHINE, 	// Key
						(BYTE*)REGISTRYKEY_APPLIANCE, 			// Sub-key
						0,						// Reserved
						KEY_READ,			// Allow all access
						&hkeyMyKey);				// Returns this handle

		if (lResult != 0)
		{
	//		consoleprintf( "IsBOMA RegOpenKeyEx %d\n", lResult);
			return FAIL;
		}

		// Write the registry entry
		lResult = RegQueryValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_BOMA_VERSION,				// Name of the value to set
						0, &Type,
						(BYTE*)buf,			// Address of value data
						&lSize);// Size of value data include null

		if (lResult != 0)
		{
	//		consoleprintf( "IsBOMA RegQueryValueEx %d\n", lResult);
			RegCloseKey(hkeyMyKey);
			return FAIL;
		}

		buf[lSize] = '\0';
		//consoleprintf( "IsBOMA %s\n", buf);

		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		iResult = SUCCESS;
	}
	
	return iResult;
}

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int SaveStatusToRegistry(int code, BOOL bCleanAll)
{
	char buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char keybuf[200];

	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		consoleprintf("SaveStatusToRegistry %s %d\n", keybuf, lResult);
		return FAIL;
	}

	if (code != 0 && code != RERR_IN_PROGRESS) {
		char const *rerr_name(int code);	
		const char *name;

		name = rerr_name(code);
		if (!name)
		        name = "unexplained error";

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_ERRSTRING,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)name,			// Address of value data
						strlen(name)+1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		if (code == RERR_UNLOAD)
			SaveRsyncErrorToRegistry(name);
	}
	else
	{
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_ERRSTRING,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
	
	}

	if (code > 0 && code != RERR_IN_PROGRESS)
		code = -code;
		
	sprintf(buf, "%d", code);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_STATUS,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	if (bCleanAll == TRUE)
	{
		// Clean out the other keys because we are in progress
		
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_ERRSTRING,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_TOTALWRITE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_TOTALREAD,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_TOTALSIZE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_LINE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTCOUNT,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTSIZE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTINDEX,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTTOTALSIZE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}		

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_RSYNC_ERROR,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_NUM_XFER_FILES,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		
	}

	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;
}

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int SaveTimeToRegistry(int code, char* regKey)
{
	char buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	double retTime;
	char keybuf[200];
	
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		consoleprintf("SaveTimeToRegistry %s %d\n", keybuf, lResult);		
		return FAIL;
	}

//	time(&nowTime);
//	retTime = 1000.0 * nowTime;
	
	retTime = computeTime();
	
	sprintf(buf, "%.f", retTime);
//	consoleprintf("SaveTime %s %s\n", regKey, buf);
	
	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)regKey,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;
}


/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int SaveStatsToRegistry(int code)
{
	get_tsd
	char 	buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char 	keybuf[200];
	unsigned long 	start, end, diff;
	double  thruput;
	
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		consoleprintf("SaveStasToRegistry %s %d\n", keybuf, lResult);
		return FAIL;
	}

	if (code != 0) {
		char const *rerr_name(int code);	
		const char *name;

		name = rerr_name(code);
		if (!name)
		        name = "unexplained error";

		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_ERRSTRING,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)name,			// Address of value data
						strlen(name)+1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
	}
	else
	{
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_ERRSTRING,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
	
	}

	
	sprintf(buf, "%.0f", (double)stats.total_written);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_TOTALWRITE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	sprintf(buf, "%.0f", (double)stats.total_read);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_TOTALREAD,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	sprintf(buf, "%.0f", (double)stats.total_size);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_TOTALSIZE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	sprintf(buf, "%.0f", (double)stats.total_transferred_size);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_TOTAL_XFER_SIZE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	sprintf(buf, "%.0f", (double)stats.num_transferred_files);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_NUM_XFER_FILES,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	if (SUCCESS != GetTimeFromRegistry(REGISTRYVALUE_STARTTIME, (long*)&start))
		goto End;
		 
	if (SUCCESS != GetTimeFromRegistry(REGISTRYVALUE_TIME, (long*)&end))
		goto End;
	 
	diff = difftime(end,start);
//	consoleprintf("SaveStats %d %d %d\n", start, end, diff);
	
	if (diff != 0)
	{
		thruput = (stats.total_written+stats.total_read)/(0.5 + diff);
		sprintf(buf, "%.0f", thruput);
//		consoleprintf( "SaveStats thru: %s\n", buf);
		
		// Write the registry entry
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_THROUGHPUT,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)buf,			// Address of value data
						strlen(buf)+1);// Size of value data include null

		if (lResult != 0)
		{
			goto End;
		}
	}
	
End:
	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;
}

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int	SaveRsyncErrorToRegistry(const char* error)
{
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char keybuf[200];
	
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		return FAIL;
	}


	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_RSYNC_ERROR,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)error,			// Address of value data
					strlen(error)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}


	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;

}

 
int	SaveFileLineToRegistry(const char* file, int line)
{
	char buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char keybuf[200];
	
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		return FAIL;
	}


	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_FILE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)file,			// Address of value data
					strlen(file)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	sprintf(buf, "%d", line);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_LINE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;

}
 
int SaveFileListCountToRegistry(struct file_list *flist)
{
	char 	buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char 	keybuf[200];
	int64 	total_size = 0;
	int		i;
		
	if (!flist)
		return FAIL;
		
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		// return error
		return FAIL;
	}


	sprintf(buf, "%d", flist->count);
	
	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_FILELISTCOUNT,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}

	for(i = 0; i < flist->count; i++)
	{
		total_size += flist->files[i]->length;
	}
	sprintf(buf, "%.0f", (double)total_size);

	// Write the registry entry
	lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_FILELISTTOTALSIZE,				// Name of the value to set
					0,						// Reserved
					REG_SZ,					// Data type
					(BYTE*)buf,			// Address of value data
					strlen(buf)+1);// Size of value data include null

	if (lResult != 0)
	{
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
		// return error
		return FAIL;
	}
	
	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);

	return SUCCESS;
}
 
int SaveFileListIndexToRegistry(const char *op, struct file_list *flist, int index, int fileCount)
{
	get_tsd
	char 	buf[100];
	long	lResult;
	HKEY	hkeyMyKey;
	long	lDisposition;
	char 	keybuf[200];
	long	lSize = sizeof(buf);
	int64 	total_size = 0;
	long 	Type;
	struct jni_stats jniStats;
	
	if (!flist)
		return FAIL;
	
	jniStats.total_size = stats.total_size;
	jniStats.total_transferred_size = stats.total_transferred_size;
	jniStats.total_written = stats.total_written;
	jniStats.total_read = stats.total_read;
	jniStats.literal_data = stats.literal_data;
	jniStats.matched_data = stats.matched_data;
	jniStats.flist_size = stats.flist_size;
	jniStats.num_files = stats.num_files;
	jniStats.num_transferred_files = stats.num_transferred_files;
//	jniStats.jni_starttime = starttime;
	strlcpy(jniStats.op,op,sizeof (jniStats.op));
	strlcpy(jniStats.fname,f_name(flist->files[index]),MAXPATHLEN);
	jniStats.flist_index = index;

#ifdef SCOREBOARD
	ap_increment_counts(tsd->sb_handle, &jniStats);
#endif		
	if (fileCount % 100 == 0)
	{
//		ap_display_scoreboard ();
		
		GetRsyncVolumeKey(keybuf, sizeof(keybuf));
		
		// Create or open the registry key
		lResult = RegCreateKeyEx(
						HKEY_LOCAL_MACHINE, 	// Key
						(BYTE*)keybuf, 			// Sub-key
						0,						// Reserved
						NULL,					// Reserved
						REG_OPTION_NON_VOLATILE,// Really save in registry
						KEY_ALL_ACCESS,			// Allow all access
						0,						// Reserved
						&hkeyMyKey,				// Returns this handle
						&lDisposition);			// Was it created or just opened?

		if (lResult != 0)
		{
			// return error
			return FAIL;
		}


		sprintf(buf, "%d", index);
		
		// Write the registry entry
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTINDEX,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)buf,			// Address of value data
						strlen(buf)+1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}

		lResult = RegQueryValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTSIZE,				// Name of the value to set
						0, &Type, 
						(BYTE*)buf,			// Address of value data
						&lSize);// Size of value data include null

		if (lResult != 0)
		{
			lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
							(BYTE*)REGISTRYVALUE_FILELISTSIZE,				// Name of the value to set
							0,						// Reserved
							REG_SZ,					// Data type
							(BYTE*)"0",			// Address of value data
							2);// Size of value data include null
		
			if (lResult != 0)
			{
				// Close the registry
				lResult = RegCloseKey(hkeyMyKey);
				// return error
				return FAIL;
			}
			else
				sprintf(buf,"0");
		}

		
		total_size = atol(buf);
		total_size += flist->files[index]->length;
		sprintf(buf, "%.0f", (double)total_size);
		
		// Write the registry entry
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_FILELISTSIZE,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)buf,			// Address of value data
						strlen(buf)+1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		
		sprintf(buf, "%.0f", (double)stats.num_transferred_files);

		// Write the registry entry
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_NUM_XFER_FILES,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)buf,			// Address of value data
						strlen(buf)+1);// Size of value data include null

		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
	
		// Close the registry
		lResult = RegCloseKey(hkeyMyKey);
	}
	return SUCCESS;
} 

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int GetStatusFromRegistry(int *pStatus)
{
	long	lResult;
	HKEY	hkeyMyKey;
	char 	buf[100];
	long	lSize = sizeof(buf);
	int		status;
	long	lDisposition;
	char 	keybuf[200];
	long 	Type;
	
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	*pStatus = 0;
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		return FAIL;
	}

	// Write the registry entry
	lResult = RegQueryValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)REGISTRYVALUE_STATUS,				// Name of the value to set
					0, &Type, 
					(BYTE*)buf,			// Address of value data
					&lSize);// Size of value data include null

	if (lResult != 0)
	{
		lResult = RegSetValueEx(hkeyMyKey,		// Handle to key to set value for
						(BYTE*)REGISTRYVALUE_STATUS,				// Name of the value to set
						0,						// Reserved
						REG_SZ,					// Data type
						(BYTE*)"",			// Address of value data
						1);// Size of value data include null
	
		if (lResult != 0)
		{
			// Close the registry
			lResult = RegCloseKey(hkeyMyKey);
			// return error
			return FAIL;
		}
		else
			sprintf(buf,"0");
	}

	status = atoi(buf);
	*pStatus = status;
	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);
	
	return SUCCESS;
}

/******************************************************************************
 *
 * DESCRIPTION:
 *
 *
 *
 ****************************************************************************/
int GetTimeFromRegistry(char*pRegKey, long *pTime)
{
	long	lResult;
	HKEY	hkeyMyKey;
	char 	buf[100];
	long	lSize = sizeof(buf);
	double	status;
	long	lDisposition;
	char 	keybuf[200];
	long 	Type;
	
	*pTime = 0;
	GetRsyncVolumeKey(keybuf, sizeof(keybuf));
	
	// Create or open the registry key
	lResult = RegCreateKeyEx(
					HKEY_LOCAL_MACHINE, 	// Key
					(BYTE*)keybuf, 			// Sub-key
					0,						// Reserved
					NULL,					// Reserved
					REG_OPTION_NON_VOLATILE,// Really save in registry
					KEY_ALL_ACCESS,			// Allow all access
					0,						// Reserved
					&hkeyMyKey,				// Returns this handle
					&lDisposition);			// Was it created or just opened?

	if (lResult != 0)
	{
		return FAIL;
	}

	// Write the registry entry
	lResult = RegQueryValueEx(hkeyMyKey,		// Handle to key to set value for
					(BYTE*)pRegKey,				// Name of the value to set
					0, &Type, 
					(BYTE*)buf,			// Address of value data
					&lSize);// Size of value data include null

	if (lResult != 0)
	{
			sprintf(buf,"0");
	}

	status = atof(buf);
//	consoleprintf("GetTime %s %f\n", buf, status);

	status = status / 1000.0;
//	consoleprintf("GetTime %s %d\n", buf, (long)status);

	*pTime = (long)status;
	// Close the registry
	lResult = RegCloseKey(hkeyMyKey);
	
	return SUCCESS;
}

int NLM_RemoveDeleteInhibitBit(char* fname, long attr)
{
	mode_t mode;
	int rc;
	mode = M_A_BITS_SIGNIFICANT;
	rc = chmod(fname, mode);
	return rc;
}				

void threadCleanup(int flag)
{
	get_tsd
	
	free_globalexclude();
	free_gidlist();
	free_uidlist();
	io_stop_buffering();	
	free_token_bufs();
	free_checksum_bufs();
	free_services();
	free_fileio_bufs();
	freeTsdVariables(flag, tsd);
}

#if 0
#undef malloc
void* _nwmalloc(size_t size, const char *file, int line)
{
	void * ptr = malloc(size);
	
	if (gInited)
		consoleprintf("%d: %x==Alloc(%d) (%s,%d)\n", getpid(), ptr, size, file, line);
	else
	{
		consoleprintf("%d: %x==Alloc(%d) (%s,%d)\n", getpid(), ptr, size, file, line);
	}
	return ptr;
}

#undef free
void _nwfree(void* pointer, const char *file, int line)
{
	if (gInited)
		consoleprintf("%d: %x==Free() (%s %d)\n", getpid(), pointer, file, line);
	else
	{
		consoleprintf("%d %x==Free() (%s %d)\n", getpid(), pointer, file, line);
	}
	free(pointer);
}

#undef strdup
char * _nwstrdup(const char*ptr, const char*file, int line)
{
	char *out = strdup(ptr);
	int len = strlen(ptr) + 1;
	
	if (gInited)
		consoleprintf("%d: %x==Alloc(%s,%d) (%s,%d)\n", getpid(), out, ptr, len, file, line);
	else
	{
		consoleprintf("%d: %x==Alloc(%s,%d) (%s,%d)\n", getpid(), out, ptr, len,file, line);
	}
	return out;
}

#undef realloc
void *_nwrealloc  (      void     *oldBlk,       size_t   size, const char* file, int line)
{
	void * ptr = realloc(oldBlk, size);

	if (gInited)
	{
		consoleprintf("%d: %x==Alloc(%x,%d) (%s,%d)\n", getpid(), ptr, oldBlk, size, file, line);
		if (oldBlk != ptr)
			consoleprintf("%d: %x==Free() (%s %d)\n", getpid(), ptr, file, line);
	}
	else
	{
		if (oldBlk != ptr)
		{
			consoleprintf("%d: %x==Alloc(%x,%d) (%s,%d)\n", getpid(), ptr, oldBlk, size, file, line);
			consoleprintf("%d: %x==Free() (%s %d)\n", getpid(), oldBlk, file, line);
		}
	}		

	return ptr;
}

#undef calloc
void * _nwcalloc  (      size_t    n,       size_t   size, const char *file, int line)
{
	void * ptr = calloc(n, size);

	if (gInited)
		consoleprintf("%d: %x==Alloc(%d,%d) (%s,%d)\n", getpid(), ptr, n, size, file, line);
	else
		consoleprintf("%d: %x==Alloc(%d,%d) (%s,%d)\n", getpid(), ptr, n, size, file, line);

	return ptr;
}
#endif

#if 0
static int  _gettemp(char * path, register int *doopen, int extraFlags);
 
int mkstemp(char * path)
{
 #ifdef  XP_OS2
          FILE * temp = tmpfile();
  
          return ( temp ?  fileno( temp) : -1 );
#else
          int  fd;
  
          return ( _gettemp( path, & fd, 0) ?  fd : -1 ); 
#endif
 }
  
int mkstempflags(char * path, int extraFlags)
{
          int  fd;
 
         return ( _gettemp( path, & fd, extraFlags) ?  fd : -1 );
}
 
char * mktemp(char * path)
{
     return( _gettemp( path, (int *) NULL, 0) ?  path : (char *) NULL);
}
 
/* NB: This routine modifies its input string, and does not always restore it. 
** returns 1 on success, 0 on failure. 
*/ 
static int _gettemp(char * path, register int *doopen, int extraFlags)
{    
     register char * start, *trv;
     struct  stat  sbuf;
     unsigned int  pid;

      pid =  getpid();
     for (trv =  path; *trv; ++trv);           /* extra X's get set to 0's */ 
     while (*--trv == 'X' ) {
             *trv = ( pid % 10) +  '0' ;
              pid /= 10;
     }

      /* 
       * check the target directory; if you have six X's and it 
       * doesn't exist this runs for a *very* long time. 
       */ 
//     for ( start = trv + 1;; --trv ){
	   for ( start = trv + 1;; trv = prevmb(trv) ){
     		char  saved;
             if (trv <=  path)
                     break;
              saved = *trv;
             if ( saved ==  '/'  ||  saved ==  '\\' ) {
                     int  rv;
                     *trv =  '\0' ;
                      rv =  stat( path, & sbuf);
                     *trv =  saved;
                     if ( rv)
                             return(0);
                     if (! S_ISDIR( sbuf.st_mode)) {
                              errno =  ENOTDIR;
                             return(0);
                     }
                     break;
             }
     }

     for (;;) {
             if (doopen) {
                     if ((*doopen =
                          open( path,  O_CREAT| O_EXCL| O_RDWR|extraFlags, 0600)) >= 0)
                             return(1);
                     if ( errno !=  EEXIST)
                             return(0);
             }
             else if ( stat( path, & sbuf))
                     return( errno ==  ENOENT ? 1 : 0);

              /* tricky little algorithm for backward compatibility */ 
             for (trv =  start;;) {
                     if (!*trv)
                             return(0);
                     if (*trv ==  'z' )
                     {
                             *trv++ =  'a' ;
	                         *trv =  'a' ;
	                         trv = nextmb(trv);
                     }
                     else {
                             if (isdigit(*trv))
                                     *trv =  'a' ;
                             else
                                     ++*trv;
                              break;
                      }
              }
      }
       /*NOTREACHED*/ 
}
#endif

void do_run_sender_exit(int f_in, int f_out, int argc, char *argv[])
{
//	get_tsd
//	rprintf(FLOG, "do_run_sender_exit(%d, %d, %s)\n", f_in, io_error, run_completion ? run_completion : "NULL");
	return;
}

void do_run_recv_exit(int f_in, int f_out, int argc, char *argv[])
{
	get_tsd
	if (io_error == 0 && lp_use_lfs(module_id))
	{
		char fullCommand[PATH_MAX*2];
		char outdir[MAXPATHLEN];
		long ccode;
		
		getcwdpath(outdir, 0,0);

		sprintf(fullCommand, "RSYNCPRS currdir=%s name=%s path=%s user=%s", outdir, lp_name(module_id), lp_path(module_id), tsd->as_user ? tsd->as_user : "");
		if (verbose)
			rprintf(FLOG, "live file system: %s\n", fullCommand);
		ccode = system(fullCommand);
		if (verbose)
			rprintf(FLOG, "live file system code: %d\n", ccode);
	}
	return;
}

#if 0 
#undef WS2_32_socket
int _nwWS2_32_socket(int domain, int type, int protocol, char*file, int line)
{
	int ret = WS2_32_socket(domain, type, protocol);
	rprintf(FLOG, "(%d) WS2_32_socket(%d,%d,%d)=>%d at %s %d\n", getpid(), domain, type, protocol, ret, file, line);
	return ret;
}

#undef WS2_32_closesocket
int _nwWS2_32_closesocket(int socket, char*file, int line)
{
	int ret = WS2_32_closesocket(socket);
	rprintf(FLOG, "(%d) WS2_32_closesocket(%d)=>%d at %s %d\n", getpid(), socket, ret, file, line);
	return ret;
}
#endif

/*
** function: SSL_Bind
** usage: 	 binds to a port using ssl information.
*/
SOCKET SSLServer_Socket(int domain, int type, int protocol)
{
	extern char* g_certname;
	extern int g_auth;
	SOCKET socketHnd = INVALID_SOCKET;
	int rcode = 0;
	WSAPROTOCOL_INFO sProtocolInfo;
	struct tlsserveropts sWS2Opts;
	struct nwtlsopts	sNWTLSOpts;
	unicode *SASKey = L"SSL CertificateIP";  //nds name for server key
	WORD flags;
	unicode uniOut[MAXPATHLEN];

	if (g_certname)
	{
	   int    icode;
//	   int   actualLen;
	   	   
//	   icode = NWUSByteToUnicode( uniOut, 80, g_certname, &actualLen );
	   icode = loc2uni(uni_table, uniOut, g_certname, 0xFF, UNI_MAP_CHAR);
	   if (icode)
	   {
	      rprintf(FLOG, "NWUSByteToUnicode returned error: %04X\n", icode);
	      return socketHnd;
	   }
	   else
		SASKey = uniOut;
	}

//zero out structures
	memset((char *)&sProtocolInfo, 0, sizeof(WSAPROTOCOL_INFO));
	memset((char *)&sWS2Opts, 0, sizeof(struct tlsserveropts));
	memset((char *)&sNWTLSOpts, 0, sizeof(struct nwtlsopts));
	
	
//setup the WSAPROTOCOL_INFO structure
	sProtocolInfo.iAddressFamily = domain;
	sProtocolInfo.iSocketType = type;
	sProtocolInfo.iProtocol = protocol;
	sProtocolInfo.iSecurityScheme = SECURITY_PROTOCOL_SSL;


//create a socket
	socketHnd = WSASocket(domain, 
						  type, 
						  protocol, 
						  &sProtocolInfo, 
						  0,
//						  SKTS_RAWCALLBACKS|WSA_FLAG_OVERLAPPED);
						  WSA_FLAG_OVERLAPPED);
	if(INVALID_SOCKET == socketHnd){
		rprintf(FLOG, "WSASocket->%d %d\n", socketHnd, WSAGetLastError());			   
		goto ERR;
	}

//setup the tlsserveropts struct
	sWS2Opts.wallet = SASKey;
	sWS2Opts.walletlen = unilen(SASKey);
	sWS2Opts.sidtimeout = 0;
	sWS2Opts.sidentries = 0;
	sWS2Opts.siddir = NULL;
	sWS2Opts.options = &sNWTLSOpts;

//setup the nwtlsopts structure

	sNWTLSOpts.walletProvider				= WAL_PROV_KMO;
	sNWTLSOpts.keysList						= NULL;
	sNWTLSOpts.numElementsInKeyList			= 0;
	sNWTLSOpts.reservedforfutureuse			= NULL;
	sNWTLSOpts.reservedforfutureCRL			= NULL;
	sNWTLSOpts.reservedforfutureCRLLen		= 0;
	sNWTLSOpts.reserved1					= NULL;
	sNWTLSOpts.reserved2					= NULL;
	sNWTLSOpts.reserved3					= NULL;


	rcode = WSAIoctl(socketHnd, 
					SO_TLS_SET_SERVER, 
					&sWS2Opts, 
					sizeof(struct tlsserveropts), 
					NULL, 
					0, 
					NULL, 
					NULL, 
					NULL);
	if(SOCKET_ERROR == rcode){
		rprintf(FLOG, "Error: %d with WSAIoctl(SO_TLS_SET_SERVER)\r\n", WSAGetLastError());
		goto ERR;
	}

	if (g_auth)
	{
		flags = SO_TLS_ENABLE | SO_TLS_SERVER | SO_TLS_AUTH_CLIENT;
		 
		rcode = WSAIoctl(socketHnd,
					    SO_TLS_SET_FLAGS,
					    &flags,
					    sizeof(flags),
					    NULL,
					    0,
					    NULL,
					    NULL,
					    NULL);

		if(SOCKET_ERROR == rcode){
			rprintf(FLOG, "Error: %d with WSAIoctl(SO_TLS_SET_FLAGS)\r\n", WSAGetLastError());
			goto ERR;
		}
	}

ERR:
	if(rcode == SOCKET_ERROR){
		closesocket(socketHnd);
		socketHnd = INVALID_SOCKET;
	}
	return socketHnd;

} 

SOCKET SSLClient_Socket(int domain, int type, int protocol)
{
	extern char* g_certfile;
	extern char* g_certname;
	extern int g_auth;
	#define NUM_OF_CERTS 1
	#define CERT_NAME L"sys:\\etc\\root.der"
	unicode *SASKey = L"RsyncCertificate";  //nds name for server key

	SOCKET serverSocket = INVALID_SOCKET;
	int rcode;
	WSAPROTOCOL_INFO sProtocolInfo;
	struct tlsclientopts sWS2Opts;
	struct nwtlsopts sNWTLSOpts;
	struct tlscert sTLSCert;
	unicode uniOut[MAXPATHLEN];
//	char outdir[MAXPATHLEN];
	WORD flags;
	
	unicode *TrustedList[NUM_OF_CERTS];

	if (g_certfile)
	{
		int    icode;
		int   actualLen;

		//ConvertNameToFullPath ( g_certfile,outdir);			

//		icode = NWUSByteToUnicodePath( uniOut, sizeof(uniOut), g_certfile, &actualLen );
		icode = loc2unipath(uni_table, uniOut, g_certfile, NULL);

		if (icode)
		{
			rprintf(FLOG,"NWUSByteToUnicodePath returned error: %04X\n", icode);
			goto ERR;
		}
		else
			TrustedList[0] = uniOut;
	}
	else
		TrustedList[0] = CERT_NAME;

	if (g_auth && g_certname)
	{
		int    icode;
		int   actualLen;
	   	   
//	   icode = NWUSByteToUnicode( uniOut, sizeof(uniOut), (const nuint8 *)g_certname, &actualLen );
		icode = loc2unipath(uni_table, uniOut, g_certfile, NULL);

		if (icode)
		{
			rprintf(FLOG, "NWUSByteToUnicode returned error: %04X\n", icode);
			return serverSocket;
		}
		else
			SASKey = uniOut;
	}

// zero out buffers
//	memset((char *)&serverAddr, 0, sizeof(struct sockaddr_in));
	memset((char *)&sProtocolInfo, 0, sizeof(WSAPROTOCOL_INFO));
	memset((char *)&sWS2Opts, 0, sizeof(struct tlsclientopts));
	memset((char *)&sNWTLSOpts, 0, sizeof(struct nwtlsopts));
	memset((char *)&sTLSCert, 0, sizeof(struct tlscert));


// set up the protocol info structure for SSL
	sProtocolInfo.iAddressFamily = domain;
	sProtocolInfo.iSocketType = type;
	sProtocolInfo.iProtocol = protocol;
	sProtocolInfo.iSecurityScheme = SECURITY_PROTOCOL_SSL;

	serverSocket = WSASocket(domain, type, protocol, &sProtocolInfo,
//							NULL, SKTS_WORKTODOCALLBACKS|WSA_FLAG_OVERLAPPED);
							0, WSA_FLAG_OVERLAPPED);

	if(INVALID_SOCKET == serverSocket){
		rprintf(FLOG, "WSASocket->%d %d\n", serverSocket, WSAGetLastError());			   
		goto ERR;
	}

	if (g_auth)
	{
	// setup the socket for SSL
		sWS2Opts.wallet = SASKey;
		sWS2Opts.walletlen = unilen(SASKey);
	}
	else
	{
	//  Previously, did not initialize the wallet	
		sWS2Opts.wallet = NULL;
		sWS2Opts.walletlen = 0;
	}
	sWS2Opts.sidtimeout = 0;
	sWS2Opts.sidentries = 0;
	sWS2Opts.siddir = NULL;
	sWS2Opts.options = &sNWTLSOpts;

	if (g_auth)
	{
		sNWTLSOpts.walletProvider				= WAL_PROV_KMO;
		sNWTLSOpts.keysList						= NULL;
		sNWTLSOpts.numElementsInTRList 	= 0; //number of certs in TRList
	}
	else
	{
		sNWTLSOpts.walletProvider 		= WAL_PROV_DER;	//the wallet provider defined in wdefs.h
		sNWTLSOpts.TrustedRootList 		= TrustedList;	//array of certs in UNICODE format
		sNWTLSOpts.numElementsInTRList 	= NUM_OF_CERTS; //number of certs in TRList
	}
	
	sNWTLSOpts.keysList 			= NULL;			//not used in this instance
	sNWTLSOpts.numElementsInKeyList = 0;			//number of elements in keylist
	sNWTLSOpts.reservedforfutureuse = NULL;			//not used
	sNWTLSOpts.reservedforfutureCRL = NULL;			//not used
	sNWTLSOpts.reservedforfutureCRLLen = 0;			//not used			
	sNWTLSOpts.reserved1			= NULL;			//not used
	sNWTLSOpts.reserved2			= NULL;			//not used
	sNWTLSOpts.reserved3			= NULL;			//not used
	
	
//make the IOCTL call
	rcode = WSAIoctl(serverSocket, SO_TLS_SET_CLIENT, &sWS2Opts,
	  			     sizeof(struct tlsclientopts), NULL, 0, NULL,
				     NULL, NULL);
	
//make sure that it was successfull
	if(SOCKET_ERROR == rcode ){
		rprintf(FLOG, "WSAIoctl failed with %d\r\n", WSAGetLastError());
		closesocket(serverSocket);
		serverSocket = INVALID_SOCKET;
		goto ERR;
	}		

	if (g_auth)
	{
		flags = SO_TLS_ENABLE;
		 
		rcode = WSAIoctl(serverSocket,
					    SO_TLS_SET_FLAGS,
					    &flags,
					    sizeof(flags),
					    NULL,
					    0,
					    NULL,
					    NULL,
					    NULL);

		if(SOCKET_ERROR == rcode){
			rprintf(FLOG, "Error: %d with WSAIoctl(SO_TLS_SET_FLAGS)\r\n", WSAGetLastError());
			closesocket(serverSocket);
			serverSocket = INVALID_SOCKET;
			goto ERR;
		}
	}
	
// return the connected socket
// or INVALID_SOCKET
ERR:
	return serverSocket;
}

#ifdef SCOREBOARD

typedef long* (*score_func)(void *);

struct scoreboard_version
{
	int version;
	score_func sFunc;
};

int regHandle=-1;
typedef int (*pRegisterScoreboard)( int , score_func );
typedef int (*pUnregisterScoreboard)( int , score_func );

int RegisterOurScoreboard ()
{
	extern int am_daemon;
	pRegisterScoreboard pScoreReg;
	long ret = 0;

	// If we are in daemon mode on the BOMA, don't register   
    if (am_daemon && (IsBOMA() == SUCCESS))
    {
    	return ret;
    }
    	
//	consoleprintf( "RegisterOurScoreboard\n");
	pScoreReg=ImportPublicObject(getnlmhandle(), "RegisterScoreboard"); 

	if (pScoreReg == NULL)
	{
//		consoleprintf( "RegisterScoreboard not found\n");
		goto Next;		/* SYMBOL_NOT_FOUND */
	}

	ret = pScoreReg(PROTOCOL_VERSION, (score_func)ap_get_scoreboard_copy); 
	if (ret == -1)
	{
		consoleprintf("RegisterScoreboard returns %x\n", ret);
		goto Next;
	}
	UnImportPublicObject(getnlmhandle(), "RegisterScoreboard"); 
	regHandle = ret;	                 
//	consoleprintf( "RegisterScoreboard %x\n", regHandle);
	
Next:	                 
	return ret;
}

int UnregisterOurScoreboard ()
{
	extern int am_daemon;
	pUnregisterScoreboard pScoreReg;
	long ret = 0;

	// If we are in daemon mode on the BOMA, don't register   
    if (am_daemon && (IsBOMA() == SUCCESS))
    {
    	return ret;
	}
	
	if (regHandle == -1)
		goto Next;

//	consoleprintf( "UnregisterOurScoreboard %x\n", regHandle);
		   
	pScoreReg=ImportPublicObject(getnlmhandle(), "UnregisterScoreboard"); 

	if (pScoreReg == NULL)
	{
		consoleprintf("UnregisterScoreboard not found\n");
		goto Next;		/* SYMBOL_NOT_FOUND */
	}

	ret = pScoreReg(regHandle, (score_func)ap_get_scoreboard_copy); 
	if (ret == -1)
	{
		consoleprintf("UnregisterScoreboard returns %x\n", ret);
		goto Next;
	}
	regHandle = -1;
	UnImportPublicObject( getnlmhandle(), "UnregisterScoreboard"); 
	                 
//	consoleprintf( "UnregisterOurScoreboard %d\n", regHandle);
Next:	                 
	return ret;
}
//#endif
#endif