#-----------------------------------------------------------------------
# rsync.MAK
#-----------------------------------------------------------------------

TARGET=rsync

!IFDEF PRODUCTION
CXFLAGS=/dDEVMOD=0
!ENDIF

MAJOR_VERSION=2
MINOR_VERSION=5
REV=6
REVISION=6

!IFDEF GENERATED
!message GENERATED defined
!ELSE
GENERATED=$(ROOT)\generated
!ENDIF
!IFDEF IMPORT
!message IMPORT defined
!ELSE
IMPORT=$(ROOT)
!ENDIF
!IFDEF JAVA_INCLUDE
!message JAVA_INCLUDE defined
!ELSE
JAVA_INCLUDE=$(TOOLS_DRV)\java\include
!ENDIF
!IFDEF FINAL
!message FINAL defined
!ELSE
FINAL=$(ROOT)\final
!ENDIF

#***********************************************************************
# Define the compiler's include paths (-I) - semi-colon separators
#***********************************************************************
XINC_SEMI=.;$(IMPORT)\include\nlm;$(IMPORT)\include\nlm\sys;$(IMPORT)\include;.\lib;.\popt

#***********************************************************************
# Define the assembler's include paths (-I) - comma separators
#***********************************************************************
XINC_COMMA=.,$(GENERATED),$(IMPORT)\nwsdk.inc,$(IMPORT)\nwsdk.inc\nlm,$(IMPORT)\nwsdk.inc\nlm\sys,$(IMPORT)\nwos.inc,$(ROOT)\s_mesg,$(JAVA_INCLUDE),$(JAVA_INCLUDE)\netware

VERBOSE=1
USE_WLINK=1
NO_ALIAS=1
NO_PACK=1

!include builtins.mak

#***********************************************************************
# Define Program version numbers and copyright strings
#***********************************************************************
NLM=$(TARGET).NLM
PROG_DESC=RSYNC 2.5.7
COPYRIGHT=Copyright 2003 Andrew Tridgell, Paul Mackerras, Martin Pool

#***********************************************************************
# MESSAGES: Defines name of message file
#***********************************************************************
#MESSAGES=   $(TARGET)

#***********************************************************************
# SCREENNAME: Defines CLIB screen name for running program
#***********************************************************************
SCREENNAME=Rsync Client 2.5.7

#***********************************************************************
# THREADNAME: Defines CLIB thread name for running program
#***********************************************************************
THREADNAME=RSyncMain

#***********************************************************************
# STACK: Defines stack size for initialization thread
#***********************************************************************
STACK=65535

LIBOBJ= lib\fnmatch.obj, lib\compat.obj, lib\snprintf.obj, lib\mdfour.obj, \
	lib\permstring.obj,  lib\inet_ntop.obj, lib\inet_pton.obj, lib\getaddrinfo.obj, lib\getnameinfo.obj, \
	lib\netware.obj, lib\netwareds.obj, lib\dalloc.obj, lib\scoreboard.obj, lib\syslog.obj,
ZLIBOBJ=zlib\deflate.obj, zlib\infblock.obj, zlib\infcodes.obj, zlib\inffast.obj, \
	zlib\inflate.obj, zlib\inftrees.obj, zlib\infutil.obj, zlib\trees.obj, \
	zlib\zutil.obj, zlib\adler32.obj,
OBJS1=rsync.obj, generator.obj, receiver.obj, cleanup.obj, sender.obj, exclude.obj, util.obj, \
	main.obj, checksum.obj, match.obj, syscall.obj, log.obj, backup.obj,
OBJS2=options.obj, flist.obj, io.obj, compat.obj, hlink.obj, token.obj, uidlist.obj, socket.obj, \
	fileio.obj, batch.obj, clientname.obj,
OBJS3=progress.obj, pipe.obj,
DAEMON_OBJ = params.obj, loadparm.obj, clientserver.obj, access.obj, connection.obj, authenticate.obj,
popt_OBJS=popt\findme.obj,  popt\popt.obj,  popt\poptconfig.obj, \
	popt\popthelp.obj, popt\poptparse.obj
OBJS=$(OBJS1) $(OBJS2) $(OBJS3) $(DAEMON_OBJ) $(LIBOBJ) $(ZLIBOBJ) $(popt_OBJS)

#***********************************************************************
# DEPENDANCIES: Defines all objects that NLM is dependant on
#***********************************************************************
DEPENDANCIES=   $(MESSAGES) \
		rsync.obj \
		generator.obj \
		receiver.obj \
		cleanup.obj \
		sender.obj \
		exclude.obj \
		util.obj \
		main.obj \
		checksum.obj \
		match.obj \
		syscall.obj \
		log.obj \
		backup.obj \
		options.obj \
		flist.obj \
		io.obj \
		compat.obj \
		hlink.obj \
		token.obj \
		uidlist.obj \
		socket.obj \
		fileio.obj \
		batch.obj \
		clientname.obj \
		progress.obj \
		pipe.obj \
		params.obj \
		loadparm.obj \
		clientserver.obj \
		access.obj \
		connection.obj \
		authenticate.obj \
		popt\findme.obj \
		popt\popt.obj \
		popt\poptconfig.obj \
		popt\popthelp.obj \
		popt\poptparse.obj \
		lib\fnmatch.obj \
		lib\compat.obj \
		lib\snprintf.obj \
		lib\mdfour.obj \
		lib\permstring.obj \
		lib\inet_ntop.obj \
		lib\inet_pton.obj \
		lib\getaddrinfo.obj \
		lib\getnameinfo.obj \
		lib\netware.obj \
		lib\netwareds.obj \
		lib\dalloc.obj \
		lib\scoreboard.obj \
		lib\syslog.obj \
		zlib\deflate.obj \
		zlib\infblock.obj \
		zlib\infcodes.obj \
		zlib\inffast.obj \
		zlib\inflate.obj \
		zlib\inftrees.obj \
		zlib\infutil.obj \
		zlib\trees.obj \
		zlib\zutil.obj \
		zlib\adler32.obj \
		.\rsync.clib\$(TARGET).imp 

#***********************************************************************
# OBJECT_FILES: Defines all files that need to be defined in the INPUT
#               section of the link file. Normally, this is all the 
#               .OBJ files. Entries are separated by ",".
#***********************************************************************
OBJECT_FILES=	$(OBJS), \
		$(IMPORT)\imports\prelude.obj

#***********************************************************************
#IMPORT_FILES: Defines all files that need to be defined in the IMPORT
#              section of the link file. Each file needs to be preceeded
#              with an "@" symbol denoting a filename as opposed to a
#              symbol name. Each entry is separated by ",".
#***********************************************************************
IMPORT_FILES=  @.\rsync.clib\$(TARGET).imp, @$(IMPORT)\imports\clib.imp, @$(IMPORT)\imports\threads.imp, @$(IMPORT)\imports\ws2nlm.imp, @$(IMPORT)\imports\locnlm32.imp, @$(IMPORT)\imports\calnlm32.imp, @$(IMPORT)\imports\dsapi.imp
 
#***********************************************************************
# EXPORT_FILES: Defines all files that need to be defined in the EXPORT
#               section of the link file. Each file needs to be preceeded
#               with an "@" symbol denoting a filename as opposed to a
#               symbol name. Each entry is separated by ",".
#***********************************************************************
#EXPORT_FILES= @.\rsync.clib\$(TARGET).exp

#***********************************************************************
# IMPORT_FUNCTIONS: Defines all functions defined in the IMPORT section
#                   of the link file. Each entry is separated by ",".
#***********************************************************************
#IMPORT_FUNCTIONS= 

#***********************************************************************
# EXPORT_FUNCTIONS: Defines all functions defined in the EXPORT section
#                   of the link file. Each entry is separated by ",".
#***********************************************************************
#EXPORT_FUNCTIONS=   

#***********************************************************************
# MODULE_DEPENDANCIES: Defines all entries in the MODULES section of the
#                      link file. Each entry is separated by ","
#***********************************************************************
#MODULE_DEPENDANCIES=

#***********************************************************************
# START_FUNCTION: Defines the function name to jump to when starting the NLM
#***********************************************************************
START_FUNCTION= _RSyncInit

#***********************************************************************
# EXIT_FUNCTION: Defines the function to call when unloading the NLM  
#***********************************************************************
EXIT_FUNCTION=	_Stop

#***********************************************************************
# FLAG_ON: Defines NLM flags in NLM header. 16 means only load in ring zero.
#***********************************************************************
#FLAG_ON=16

#***********************************************************************
# Define the main COMPILE rule for this NLM's files                     
#***********************************************************************
compile:    

.c.obj:
#   $(SILENT_SETFLAGS)set WCC386= /zp=1 /ei /od /3s /w3 /s /zq /ez /ri\
   $(SILENT_SETFLAGS)set WCC386= /zp=1 /ei /3s /w3 /s /zq /ez /ri\
	-DWATCOM -DWATCOM11 -DNETWARE -DN_PLAT_NLM -DIAPX386\
	-D__NO_MATH_OPS -Dx86 -D_X86_ -DTRACING -D__NETWARE__ -DHAVE_CONFIG_H -fo$@
   $(SILENT_SET)set INC386=$(INC_SEMI)
   $(SILENT_SET)set WCGMEMORY=4096
   -@echo Building $@
   $(COMP_CMD) $<

clean:
   @echo Cleaning $(TARGET)...
   $(DEL_CMD) $(TARGET).nlm
   $(DEL_CMD) *.obj
   $(DEL_CMD) lib\*.obj
   $(DEL_CMD) zlib\*.obj
   $(DEL_CMD) popt\*.obj   
   $(DEL_CMD) $(TARGET).map
   $(DEL_CMD) $(TARGET).lnk

#***********************************************************************
# Link the NLM defined by $(NLM)
#***********************************************************************
KEEP_FILES=1
VERBOSE=1
!INCLUDE linkrule.mak

